; PICC2RD21.ASM
; Decodifica canales codificadas en SECA emulando una tarjeta original, permitiendo la visualizacion de canales libres (FTA).
; PIC16F876 or PIC16F876 + 24LC32
; (c) 2001 PICC2RD & The Picc2rd Team 


		LIST        P=16F876, F=INHX8M
		include     "P16F876.inc"
		include     "versinfo.inc"


		; Flags de configuracin
		__CONFIG	_BODEN_OFF & _CP_OFF & _WRT_ENABLE_ON & _PWRTE_OFF & _WDT_OFF & _XT_OSC & _DEBUG_OFF & _CPD_OFF & _LVP_OFF 
		__IDLOCS	0xFFFF

;define SIMMODE
;#define COMPILE_873_VERSION

#ifndef COMPILE_873_VERSION
LenMAX		EQU	0x5F
PPVMAX		EQU	.26	; numero maximo de eventos PPV
#else
LenMAX		EQU	0x50
PPVMAX		EQU	.16	; numero maximo de eventos PPV
#endif
PPVMAXBYTES	EQU	PPVMAX*3

	cblock 0x20
EEDATA2
EEADRH2
EEADR2
CONTROL	;Bit 0      Activado = PPV seguro
	;Bit 1      Activado = Leds en catodo comn
	;Bit 2      Activado = Usar eeprom externa
	;Bit 3      Activado = Proteccin de Actualizacin de Claves
	;Bit 4      Activado = Log
	;Bit 5	    Activado = AutoPPUA
	;Bit 6	    Activado = Ignorar PBM
	;Bit 7	    Activado = Ignorar chequeo fecha (nano 22 ins 40)
LEDS
COUNTER
DUMMY1
DUMMY2
DUMMY3
DUMMY4
FSR2

; Espacio para el Comando SECA
IC_CLA
IC_INS
IC_P1
IC_P2
IC_LEN

BUFFER:0x10	;Debe estar en frontera de 8 bytes
KEYTMP:0x10	;almacena temporalmente la key
PK:8
SK:8

P1KEY		;provider al que pertenece la key
P2KEY		;indice de la key
TEMP:8
CONTROL2	;Bit 0      Activado = Actualizar clave secundaria
		;Bit 1	LastIns error    
		;Bit 2      
		;Bit 3      Flag modo programacin se habilitan las instrucciones de actualizacin
		;Bit 4	
		;Bit 5      Activo   = Capturar comando
		;Bit 6      Activado = No se ha encontrado EEPROM externa
		;Bit 7

EcmEMM_CONTROL	;Bit 0      Canal liberado (nano 04)
		;Bit 1      Fecha ok (nano 27)
		;Bit 2      PBM ok   (nano 13)
		;Bit 3      Controlwords ok (nano D1)
		;Bit 4	9015
		;Bit 5	(internal USE)
		;Bit 6	9009
		;Bit 7	97xx

C34DATA:3	;*The Picc2rd Team*	Para guardar el comando de la Instr_34
NANOCNT		; Cuenta num de nanos en ins 3c/40
reg80		;contiene estado de protecciones
NANOBitmap	; Cuenta num de nanos en ins 3c/40 por STATUSBYTE 97xx
PREVINS		; Instruccion anterior
CONTROLA	;Bit 0      Activado = PPV fichas seguro
	;Bit 1
	;Bit 2
	;Bit 3
	;Bit 4 
	;Bit 5
	;Bit 6
	;Bit 7
DUMMY5
DUMMY6
	endc

#ifdef COMPILE_873_VERSION
	cblock DUMMY6+1
PPVCNT		; Contador 
PPVPOS		; Posicion del 1er byte del contador (PPVPOS=PPCVNT*3)
	endc
#else
	cblock	0x120	; Tabla en memoria para guardar los eventos PPV
PPVCNT		; Contador 
PPVPOS		; Posicion del 1er byte del contador (PPVPOS=PPCVNT*3)
PPVTBL:PPVMAXBYTES	; Reservamos una tabla con los eventos
	endc
#endif

cbank0          MACRO
                bcf     PCLATH,3
                bcf     PCLATH,4
		ENDM

cbank1          MACRO
                bsf     PCLATH,3
                bcf     PCLATH,4
		ENDM

cbank2          MACRO
                bcf     PCLATH,3
                bsf     PCLATH,4
		ENDM

cbank3          MACRO
                bsf     PCLATH,3
                bsf     PCLATH,4
		ENDM

cbankx		MACRO  nbank
	IF (nbank&1)!=0
		bsf     PCLATH,3
	ELSE
		bcf     PCLATH,3
	ENDIF
	IF (nbank&2)!=0
		bsf	PCLATH,4
	ELSE
		bcf	PCLATH,4
	ENDIF
	ENDM

;Macros para hacer llamadas y saltos entre bancos

xcall	MACRO adest
	cbankx #v(adest>>.11)
	errorlevel -306
	call   adest
	errorlevel +306
	cbankx #v($>>.11)
	ENDM

xgoto	MACRO  adest
	cbankx #v(adest>>.11)
	errorlevel -306
	goto   adest
	errorlevel +306
	ENDM

cbankset   	MACRO	nbank
	errorlevel -306
	cbankx	nbank
	ENDM

cbankreset 	MACRO
	cbankx	$>>.11
	errorlevel +306
	ENDM

;O1=O1H:O1L O2=O2H:O2L
;Res: si O1=O2 -> Z=1 & C=1
;     si O1>O2 -> Z=0 & C=1
;     si O1<O2 -> Z=0 & C=0
Cmp16		MACRO	O1H,O1L,O2H,O2L
		LOCAL	cmp16end
		movf	O2H,w
		subwf	O1H,w
		btfss	STATUS,C
		goto	cmp16end	;<
		btfss	STATUS,Z
		goto	cmp16end	;>
		movf	O2L,w
		subwf	O1L,w
cmp16end				;<,=,>
		ENDM

;Res: si O1=O2 -> Z=1 & C=1
;     si O1>O2 -> Z=0 & C=1
;     si O1<O2 -> Z=0 & C=0
Cmp16i		MACRO	O1H,O1L,VI16
		LOCAL	cmp16iend
		movlw	HIGH(VI16)
		subwf	O1H,w
		btfss	STATUS,C
		goto	cmp16iend	;<
		btfss	STATUS,Z
		goto	cmp16iend	;>
		movlw	LOW(VI16)
		subwf	O1L,w
cmp16iend				;<,=,>
		ENDM

; Para aprovechar las 8K del 876 y minimizar el tener que estar cambiando el valor de PCLATH se ha partido
; la memoria del program en 4 bloques de 2K (el 876 direcciona 2K sin necesidad de utilizar PCLATH)
; Banco 0 - PCLATH = 00 ( 00000 ) - 0000/7FFF
; Banco 1 - PCLATH = 08 ( 01000 ) - 0800/0FFF
; Banco 2/3 	 = Flash MEMORY - 1000/1FFF

;**************************************************************************************************
;* INICIO                                                                                         *
;**************************************************************************************************
			ORG	0x0000	;Empieza el codigo aqui
		goto    Init

			ORG	0x0004	;Nos saltamos el vector de interrupcin
		retfie
		
			ORG	0x0010
;Tabla de rutinas
;Init
k_Init			goto	Init

;I/O
k_Send			goto	Send
k_Receive		goto	Receive
k_Std_pause		goto	Std_pause
k_Pause			goto	Pause
k_Rd_eeprom 	   	goto	Rd_eeprom
k_Wr_eeprom		goto	Wr_eeprom
k_FLASH_send		goto	FLASH_send
k_PFLASH_send		goto	PFLASH_send
k_RAM_send		goto	RAM_send
k_i2c_test		goto	i2c_test
k_i2c_controlW		goto	i2c_controlW
k_i2c_controlR		goto 	i2c_controlR
k_i2c_write_byte	goto	i2c_write_byte
k_i2c_read_byte		goto	i2c_read_byte
k_StartBit		goto	StartBit
k_StopBit		goto	StopBit

;Loader
k_Ldr_RdMem		goto	Ldr_RdMem
k_Ldr_WrMem		goto	Ldr_WrMem
k_Ldr_RdFlash		goto	Ldr_RdFlash
k_Ldr_WrFlash		goto	Ldr_WrFlash
k_Ldr_Exec		goto	Ldr_Exec
k_Ldr_Loop		goto	Ldr_Loop

;Acceso a memoria
k_Rd_Memory		goto	Rd_Memory
k_Wr_Memory		goto	Wr_Memory
k_Rd_Flash		goto	Rd_Flash
k_Wr_Flash		goto	Wr_Flash
k_Rd_ExtMem		goto	Rd_ExtMem
k_Wr_ExtMem		goto	Wr_ExtMem
k_Rd_PFlash		goto	Rd_PFlash
k_Wr_PFlash		goto	Wr_PFlash

;Movimiento de datos
k_Store			goto	Store
k_Restore		goto	Restore
k_Swap8			goto	Swap8
k_Swap4			goto	Swap4
k_Move8			goto	Move8
k_FillMem		goto	FillMem
k_GetCommandHeader	goto	GetCommandHeader
k_LoadBuffer		goto	LoadBuffer
k_StoreBuffer		goto	StoreBuffer

;Log
k_Log			goto	Log

;Encriptacion
k_Encrypt		goto	Encrypt
k_Decrypt		goto	Decrypt
k_Tabla1		goto	Tabla1
k_Tabla2		goto	Tabla2

			ORG	0x0050

ATRDATA		DW	0x3B,0xF7,0x11,0x00,0x01,0x40,0x96
			DW	0x54,0x30,0x04
			DW	0x0E,0x6C,0xB6,0xD6
ATRLen		EQU	$-ATRDATA


Init 		   
		clrf    PCLATH
		call    Std_pause
		movlw   0xF0
		tris    PORTA
		movlw   0xF0
		movwf   PORTA 
		clrf    LEDS
		movlw   0x7F
		option			;Load OPTION register with 0x7f (PORT B pull-ups enabled)
		clrf    CONTROL
		clrf	CONTROLA
		clrf    CONTROL2

		call    ResetKey        ;inicializa la cache de key

		movlw   LOW(BAUDRATE)
		call    Rd_eeprom       ;Leemos Configuracin envio trfico
		bsf     STATUS,RP0      ;Selects Bank 1
		movwf   SPBRG
		movf    SPBRG,F         ;Miramos si es cero
		bsf     TXSTA,TXEN
		bcf     STATUS,RP0      ;Back to Bank 0
		btfss   STATUS,Z
			bsf     RCSTA,SPEN

		movlw	LOW(CONFIGBYTE)	;Leemos el ConfigByte
		call	Rd_eeprom
		movwf	CONTROL

		movlw	LOW(CONFIGEX)	;Leemos el ConfigExByte
		call	Rd_eeprom
		movwf	CONTROLA

		call	i2c_test        ;Miramos si hay eeprom externa
		btfsc	STATUS,C        ;Si no la hay
			bsf     CONTROL2,6      ;Marcamos el Flag 6
		btfsc   STATUS,C        ;Si no la hay
			bcf     CONTROL,2       ;Forzamos Flag Flash interna
		bcf     CONTROL2,5      ;Desctivamos el Flag de Captura de Comando

		movlw	0x0f			;Enciende todos los leds durante el ATR
		btfss   CONTROL,1		;Tipo de Led
			xorlw   0x0F
		movwf   PORTA
                                            
;Lee los bytes de ATR almacenados en la flash y los envia

		movlw	HIGH(ATRDATA)
		movwf	EEADRH2
		movlw	LOW(ATRDATA)
		movwf	EEADR2
		movlw   ATRLen		;Longitud del comando ATR
		movwf	IC_LEN
		call	PFLASH_send
		xgoto	SECA_Init                     

	IFDEF	SIMMODE
;**************************************************************************************************
; Rutinas para utilizar depurando con el simulador de MPLAB.

;Receive: Colocar un estimulo de registro en la dir. Receive al registro W
Receive
		movwf	TEMP+4
		movwf	TEMP+6
		return

ChkSend
		movf	IC_LEN,f
		btfsc	STATUS,Z
		retlw	0x00
		decf	IC_LEN,f        

;Send: Colocar un trace point.
Send
		movwf	TEMP+6
		movwf	TEMP+7
		return
	ELSE
;**************************************************************************************************
ChkSend
		movf	IC_LEN,f
		btfsc	STATUS,Z
		retlw	0x00
		decf	IC_LEN,f        
Send        
		movwf   TXREG           ;Para el envio de trfico
		movwf   TEMP+6
		movlw   0x32		;Pausa entre caracteres +- 170 us configurable en cada decoder
		call    Pause			
		bcf     PORTB,7     	
		movlw   B'01111111'
		tris    PORTB        	;RB7 salida
		clrf    TEMP+7
		movlw   0x08            ;1 start+7 bits datos a enviar
		movwf   TEMP+4         
send_loop   
		call    Std_pause    	;pausa a 9600 +-93us
		rrf     TEMP+6,f       
		rrf     TEMP+6,W
		andlw   0x80
		xorwf   TEMP+7,f       
		xorwf   PORTB,W
		xorwf   PORTB,f
		decfsz  TEMP+4,f
		goto    send_loop
		call    Std_pause	;bit 8 de datos
		movf    TEMP+7,W       	;Calcula la paridad par
		xorwf   PORTB,W
		xorwf   PORTB,f
		call    Std_pause	;Envia la paridad
		movlw   B'11111111'  	;
		tris    PORTB        	;RB7 entrada
		movlw   0x3E         	;2 bit de stop
		goto    Pause        	
;**************************************************************************************************
Receive     
		btfsc   PORTB,7
			goto	Receive	;Esperamos el start bit
		movlw   0x2D		;Esperamos 1 bit+1/2 datos
		call    Pause
		movlw   0x09		;Recibir 8 bits datos+ 1 paridad
		movwf   TEMP+4
Receive_loop 
		bcf     STATUS,C
		btfsc   PORTB,7
			bsf     STATUS,C
		rrf     TEMP+6,f   
		call    Std_pause
		nop				;ajuste fino este bucle es menor que en el send
		nop
		decfsz  TEMP+4,f
		goto    Receive_loop
		rlf	TEMP+6,f		;Ignorar paridad		
		movlw   0x1D		;Recibir 1 bit, falta 1/2 bit para enviar el trafico
		call    Pause
		movf    TEMP+6,W	
		movwf   TXREG           ;Para el envio de trfico
		return
	ENDIF
;*****************************
Std_pause   
		movlw	0x1A            ;Pausa estndar para enviar/recibir con protocolo serie
Pause       
		movwf	TEMP+5          ;Hace una pausa del tiempo indicado en W
Pause_loop  
		decfsz	TEMP+5,f
		goto	Pause_loop
		retlw	0x00            

;**************************************************************************************************
;* LEER UN BYTE DE LA EEPROM DEL PIC                                                              *
;**************************************************************************************************
;* W = Direccin y Byte leido al salir                                                            *
;**************************************************************************************************
Rd_eeprom   
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADR
                bsf     STATUS,RP0      ;Select Bank 3
                bcf     EECON1,EEPGD
                bsf     EECON1,RD
                bcf     STATUS,RP0      ;Select Bank 2
                movf    EEDATA,W
                bcf     STATUS,RP1      ;Select Bank 0
                return
;**************************************************************************************************
;* ESCRIBE UN BYTE A LA EEPROM DEL PIC                                                            *
;**************************************************************************************************
;* EEADR2 = Direccin  W=Dato                                                                     *
;**************************************************************************************************
Wr_eeprom   
                bcf     PIR2,EEIF
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEDATA
                bcf     STATUS,RP1      ;Select Bank 0
                movf    EEADR2,W
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADR
                bsf     STATUS,RP0      ;Select Bank 3
                bcf     EECON1,EEPGD
                bsf     EECON1,WREN
                movlw   0x55
                movwf   EECON2
                movlw   0xAA
                movwf   EECON2
                bsf     EECON1,WR
                bcf     STATUS,RP0      
                bcf     STATUS,RP1      ;Select Bank 0

		btfss   PIR2,EEIF
		goto    $-1

		bsf     STATUS,RP0
		bsf     STATUS,RP1      ;Select Bank 3

		bcf     EECON1,WREN
		bcf     STATUS,RP0
		bcf     STATUS,RP1      ;Select Bank 0
		return
;**************************************************************************************************
;Envia la cadena de datos contenida en la FLASH del 876 a travs del puerto serie
;La direccin viene en EEADR2 la parte baja y en EEADRH2 la alta. En W est el nmero de bytes a enviar
;**************************************************************************************************
FLASH_send 
	movwf   COUNTER
	subwf   IC_LEN,w
	btfsc   STATUS,C
	goto    FLASH_send_loop
	addwf   COUNTER,f
	btfsc   STATUS,Z
	return
FLASH_send_loop
            movf    EEADR2,W
            call    Rd_Memory       ; lee dato
            incf    EEADR2,F
		btfsc	STATUS,Z
			incf	EEADRH2,f       ;hay acarreo: ajusta parte alta
		call    ChkSend        ; y lo enva
		decfsz	COUNTER,f
            goto    FLASH_send_loop
		return

;Envia una cadena contenida en flash
;EEADR2: parte baja de la direccion
;EEADRH2: parte alta
;W: longitud
PFLASH_send
	movwf   COUNTER
	subwf   IC_LEN,w
	btfsc   STATUS,C
	goto    PF_send_loop
	addwf   COUNTER,f
	btfsc   STATUS,Z
	return
PF_send_loop
		call	Rd_PFlash
		call	ChkSend   		;Enviar byte
		incf	EEADR2,f			;Siguiente byte
		btfsc   STATUS,Z
			incf    EEADRH2,f
		decfsz  COUNTER,f    
		goto    PF_send_loop
		return

;Envia una cadena contenida en RAM
;FSR: primer byte a enviar
;w: num bytes a enviar
RAM_send
	movwf   COUNTER
	subwf   IC_LEN,w
	btfsc   STATUS,C
	goto    RAM_send_loop
	addwf   COUNTER,f
	btfsc   STATUS,Z
	return
RAM_send_loop
		movf	INDF,w
		call	ChkSend
		incf	FSR,f
		decfsz	COUNTER,f
		goto	RAM_send_loop
		return

;Envia una cadena contenida en EEPROM
;EEADR2: Dir inicial
;W:	num bytes
EEPROM_send
	movwf   COUNTER
	subwf   IC_LEN,w
	btfsc   STATUS,C
	goto    EEPROM_send_loop
	addwf   COUNTER,f
	btfsc   STATUS,Z
	return
EEPROM_send_loop
		movf	EEADR2,w
		call	Rd_eeprom
		call	ChkSend
		incf	EEADR2,f
		decfsz	COUNTER,f
		goto	EEPROM_send_loop
		return

;Envia una cadena de FF hasta completar la longitud pedida
Send_FF
		movf	IC_LEN,f
		btfsc	STATUS,Z
			return
		movlw	0xff
		call	ChkSend
		goto	Send_FF
		
;**************************************************************************************************
;* RUTINAS GESTION BUS I2C                                                                        *
;**************************************************************************************************
i2c_test
                call    StartBit
                movlw   0xA0        
                goto    i2c_write_byte
;--------------------------------------------------------------------
i2c_controlW 
                call    StartBit
                movlw   0xA0        
                call    i2c_write_byte
                btfss   STATUS,C
                return
                goto    i2c_controlW
;--------------------------------------------------------------------
i2c_controlR
                call    StartBit
                movlw   0xA1
                call    i2c_write_byte
                btfss   STATUS,C
                return
                goto    i2c_controlR
;--------------------------------------------------------------------
;Send a byte stored in W to external EEPROM
i2c_write_byte 
                movwf   EEDATA2
                movlw   B'11001111'
                tris    PORTB                ; Configura SDA como salida
		movlw	0x08
		movwf	TEMP+5
i2c_write_byte_loop
		rlf	EEDATA2,f
		call	i2c_write_bit_x
		decfsz	TEMP+5,f
		goto	i2c_write_byte_loop
                goto    i2c_read_bit

;--------------------------------------------------------------------
;Read a byte from external EEPROM into EEDATA2
i2c_read_byte    
                movlw   B'11011111'		;load value
                tris    PORTB			;Configura SDA como entrada
		movlw	0x08
		movwf	TEMP+5
i2c_read_byte_loop
		call    i2c_read_bit_x
                rlf     EEDATA2,f
		decfsz	TEMP+5,f
		goto	i2c_read_byte_loop
                bsf     STATUS,C
                goto    i2c_write_bit

;*******************************************
;External EEPROM Start/Stop Bit
;*******************************************
StartBit   
                bsf     PORTB,4		;SDA -> High
                movlw   B'11001111'		;Load value
                tris    PORTB			;Define SDA and SCLK output
                bsf     PORTB,5		;SCLK -> High
                bcf     PORTB,4		;SDA -> Low
                bcf     PORTB,5		;SCLK -> Low
                return				;return from subroutine
;--------------------------------------------------------------------
StopBit    
                bcf     PORTB,4		;SDA -> Low
                movlw   B'11001111'		;Load value
                tris    PORTB			;SDA como salida
                bsf     PORTB,5		;SCLK -> High
                bsf     PORTB,4		;SDA -> High
Trans_0
                bcf     PORTB,5		;SCLK -> Low
                return				;return from subroutine
;--------------------------------------------------------------------
i2c_write_bit  
                movlw   B'11001111'
                tris    PORTB           ;SDA como salida
i2c_write_bit_x  
                btfss   STATUS,C
                bcf     PORTB,4     ;SDA -> Low
                btfsc   STATUS,C
                bsf     PORTB,4     ;SDA -> High
                bsf     PORTB,5     ;SCL -> High
                goto    Trans_0
;--------------------------------------------------------------------
i2c_read_bit    
                movlw   B'11011111'
                tris    PORTB       ;SDA as input
i2c_read_bit_x   
                bsf     PORTB,5     ;SCL -> High
                bsf     STATUS,C
                btfss   PORTB,4     ;Test SDA
                bcf     STATUS,C
                bcf     PORTB,5     ;SCL -> Low
                return
;*************************************************************************************

Swap8           call    Swap4
                goto    Swap4_1
Swap4           movwf   TEMP
Swap4_1         call    Swap1
                call    Swap1
                call    Swap1
Swap1           movf    TEMP,W
                movwf   FSR
                movf    INDF,W
                movwf   EEDATA2
                movf    EEADR2,W
                movwf   FSR
                movf    INDF,W
                movwf   DUMMY2
                movf    EEDATA2,W
                movwf   INDF
                movf    TEMP,W
                movwf   FSR
                movf    DUMMY2,W
                movwf   INDF       
                incf    EEADR2,f
                incf    TEMP,f
                return   
;*************************************************************************************
Move8           movwf   TEMP
                movlw   8
                movwf   TEMP+1
Move8_loop      movf    TEMP,w
                movwf   FSR
                movf    INDF,w
                movwf   EEDATA2
                movf    EEADR2,w
                movwf   FSR
                movf    EEDATA2,w
                movwf   INDF
                incf    TEMP,f
                incf    EEADR2,f
                decfsz  TEMP+1,f
                goto    Move8_loop
		movf    TEMP,w
                return                              

ClearBuffer
                clrf   	BUFFER
                clrf   	BUFFER+1
                clrf   	BUFFER+2
                clrf   	BUFFER+3
                clrf   	BUFFER+4
                clrf   	BUFFER+5
                clrf   	BUFFER+6
                clrf   	BUFFER+7
		return
	
;*************************************************************************
;Rellena una zona de memoria con un valor dado
;w:valor
;COUNTER:num bytes
;FSR: dir inicial
FillMem		movwf	INDF
		incf	FSR,f
		decfsz	COUNTER,f
		goto	FillMem
		return

;**************************************************************************************************
;* Calcula el offset en la FLASH del 876 de la key a utilizar
;* Devuelve en 0x10 el offset de la key y en EEADRH2 la pgina. 
CalcKeyAdr       
                movf    IC_P1,W
                movwf   DUMMY1
                movf    IC_P2,W
                movwf   DUMMY2
                clrf    TEMP+0
                rrf     DUMMY1,f        ;Pasa los 2 bits bajos del num. de provider a los altos de 0x10
                rrf     TEMP+0,f        ;Equivalente a desplazar a la izda 6 bits. Esto es porque cada provider ocupa 64 bytes (2^6)
                rrf     DUMMY1,W        ;W contiene el los bits 1-4 del provider
                rrf     TEMP+0,f
                andlw   0x03            ;Se queda con los bits 2-3 del provider
                addlw	HIGH(PKEYS-BASE_DATOS)
		movwf   EEADRH2         ;que marcan la pgina (en una pgina (256 bytes) caben 4 providers (4 prov*8 keys*8 bytes/key)
                movlw   0x07         
                andwf   DUMMY2,f        ;Coge el nmero de la key
CalcKeyAdr_loop       
                movlw   0x08            ;Cada key ocupa 8 bytes
                decf    DUMMY2,f
                btfsc   DUMMY2,7        ;Mientras sea positivo, continua el bucle (acaba con el valor -1(0xff))
                return
                addwf   TEMP+0,f
                goto    CalcKeyAdr_loop

;**************************************************************************************************
; Calcula el offset en la eeprom externa de los datos del proveedor especificado en IC_P1
; Devuelve el W el offset y en EEADRH2 la pgina
CalcProvAdr
		movlw	HIGH(PROV_INFO-BASE_DATOS)
                movwf   EEADRH2
                movf    IC_P1,W
                andlw   0x0F
                movwf   DUMMY1
                incf    DUMMY1,F
                movlw   LOW(PROV_INFO)
		goto	CalcProvAdr_1
CalcProvAdr_loop
                addlw   ProvINFOLen
                btfsc   STATUS,C
                incf    EEADRH2,f
CalcProvAdr_1
                decfsz  DUMMY1,f
                goto    CalcProvAdr_loop
                return

;**************************************************************************************************
; Calcula el offset en la eeprom externa del PBM del proveedor especificado en IC_P1
; Devuelve en EEADRH2:EEADR2

CalcPBMAdr
		movf    IC_P1, W
		movwf   EEADR2		; Ahora toca ver el PBM y recuperarlo
		bcf	STATUS,C
		rlf     EEADR2,f
		rlf     EEADR2,f
		rlf     EEADR2,f  	; multiplico por 8 el proveedor
		movlw   HIGH(PBM_INFO-BASE_DATOS)   ; Direccion de comienzo de las PBM
		movwf   EEADRH2
		return
;**************************************************************************************************
; Lee una key de la FLASH del 876. El offset viene en TEMP+0. Se almacena donde indica el registro indirecto
Get_key     
                movf    TEMP+0,W
                call    Rd_Memory
                movwf   INDF
                incf    FSR,f
                movlw   0x07            ;Leer 8 bytes
                movwf   TEMP+1             ;0x11 es el contador del bucle
Get_key_loop  
                call    Rd_Memory_Next
                movwf   INDF
                incf    FSR,f
                decfsz  TEMP+1,f
                goto    Get_key_loop
                return
;**************************************************************************************************
;Actualiza la fecha de suscripcin
UpdateDate
                call    CalcProvAdr
                addlw   0x16            ;Offset de la fecha
                movwf   EEADR2
		movlw	0x02
		call	LoadBuffer
		btfsc   CONTROL,3       ;No realizar si la proteccin de actualizaciones est activada
                return
		movlw	0x02
		call	UpdateMem
                return
;**************************************************************************************************
;Actualiza la clave primaria o secundaria
UpdateKey
                call    Restore
                movwf   IC_P2
                call    LoadBuffer8
                call    Decrypt
                call    CalcKeyAdr      ;Offset de la key en EEPROM externa
		btfss	CONTROL2,0      ;Si es prim. key
		goto	IsPrimKey
                movlw   HIGH(SKEYS-PKEYS)	;desplazamiento de keys secundarias
                addwf   EEADRH2,F       ;Offset de la keys secundarias en 0x0800
IsPrimKey
		movf	TEMP+0,w
		movwf	EEADR2
		btfsc   CONTROL,3       ;No realizar si la proteccin de actualizaciones est activada
			return
		call	UpdateMem8
		call    ResetKey        ;Recargar la key
                return
;**************************************************************************************************
;* GET COMMAND HEADER                                                                             *
;**************************************************************************************************
GetCommandHeader
		movlw   IC_CLA
		movwf   FSR
Com_loop    
		call    Receive
		movwf   INDF
		movwf   TEMP+0              ;TEMP+0 contiene el ultimo byte leido (al salir la longitud)
		incf    FSR,f
		btfsc   FSR,3
		goto    Com_loop
		return
;**************************************************************************************************
;* GET COMMAND DATA                                                                               *
;**************************************************************************************************
GetCommandData
                clrf    FSR2
                movf    IC_LEN,W
		btfsc	STATUS,Z  ;0 bytes: no recibir nada
		return
                movwf   COUNTER
GetCmdData_loop 
                call    Receive
                call    Store
                decfsz  COUNTER,f
                goto    GetCmdData_loop
                return
;**************************************************************************************************
;* CHECK SIGNATURE                                                                                *
;**************************************************************************************************
CheckSignature
                movlw   0x08
                subwf   IC_LEN,W         ;Ajusta el numero de bytes que entran en la computacin
                movwf   COUNTER
                movwf   FSR2            ;Comprueba que el comando contenga el nano 82 de la
                decf    FSR2,F          ;firma 9 posiciones antes del final
                call    Restore
                xorlw   0x82
                btfss   STATUS,Z        
                retlw   0x01            ;Devuelve error (No hay firma)
                call    InitHashBuf     ;Inicializa el Hash Buffer
                clrf    FSR2
CheckSign_loop              
                call    XorBuffer
                call    LoadKeys
                call    Encrypt
                movf    COUNTER,F
                btfss   STATUS,Z
                goto    CheckSign_loop

                bsf     LEDS,1          ;Activamos LED2 Clave Falsa
                movlw   BUFFER
                movwf   FSR
                movlw   0x08
                movwf   COUNTER
CheckSign_loop2
                call    Restore
                xorwf   INDF,W
                btfss   STATUS,Z
                retlw   0x02
                incf    FSR,F
                decfsz  COUNTER,F
                goto    CheckSign_loop2
                call    LoadKeys        
                bcf     LEDS,1          ;Desactivamos LED2 Clave Falsa
                retlw   0x00
XorBuffer
                movlw   BUFFER
                movwf   FSR
XorBuffer_loop
                call    Restore
                xorwf   INDF,F
                decf    COUNTER,F
                btfsc   STATUS,Z
                return
                incf    FSR,F
                btfss   FSR,3           ;CUIDADO!!!
                goto    XorBuffer_loop
                return
InitHashBuf
		call	ClearBuffer	;Inicializa Hash Buffer a ceros

                movf    IC_P1,W
                andlw   0xE0
                movwf   DUMMY1
                xorlw   0x20
                btfsc   STATUS,Z
                goto    InitHashBuf1
                movf    DUMMY1,W
                xorlw   0x40
                btfsc   STATUS,Z
                goto    InitHashBuf2
                movf    DUMMY1,W
                xorlw   0x60
                btfsc   STATUS,Z
                goto    InitHashBuf3
InitHashBuf0                            ;Hash Buffer a ceros                
                return
InitHashBuf1                            ;Inicializa Hash Buffer a UA,0,0
		movlw	HIGH(TarjetaUA-BASE_DATOS)
                movwf   EEADRH2
                movlw   LOW(TarjetaUA-BASE_DATOS)+2
                call    Rd_Memory
                movwf   BUFFER+0
                call    Rd_Memory_Next
                movwf   BUFFER+1
                call    Rd_Memory_Next
                movwf   BUFFER+2
                call    Rd_Memory_Next
                movwf   BUFFER+3
                call    Rd_Memory_Next
                movwf   BUFFER+4
                call    Rd_Memory_Next
                movwf   BUFFER+5
                return
InitHashBuf2                            ;Inicializa Hash Buffer a PPUA,0,0,0,0
                call    CalcProvAdr     ;Offset Provider Info
                addlw   0x12            ;Offset PPUA
                call    Rd_Memory
                movwf   BUFFER+0
                call    Rd_Memory_Next
                movwf   BUFFER+1
                call    Rd_Memory_Next
                movwf   BUFFER+2
                call    Rd_Memory_Next
                movwf   BUFFER+3
                return
InitHashBuf3                            ;Inicializa Hash Buffer a SA,0,0,0,0,0                  
                call    CalcProvAdr
                addlw   0x12
                call    Rd_Memory
                movwf   BUFFER+0
                call    Rd_Memory_Next
                movwf   BUFFER+1
                call    Rd_Memory_Next
                movwf   BUFFER+2
                return
;**************************************************************************************************
;* LOAD KEYS                                                                                      *
;**************************************************************************************************
LoadKeys
		movlw   0x1f
		andwf   IC_P1,w
		xorwf   P1KEY,w
		btfss   STATUS,Z
		goto	loadnew
		movlw   0x0f
		andwf   IC_P2,w
		xorwf   P2KEY,w
		btfsc   STATUS,Z
		goto	keyloaded
                
loadnew
		call	CalcKeyAdr	;cargar key
                movlw   KEYTMP        
                movwf   FSR       
                call    Get_key         ;Carga la PK
                movlw   HIGH(SKEYS-PKEYS)
                btfsc   IC_P1,4         ;Si se utiliza PK+SK apuntar a SK
                addwf   EEADRH2,F
                call    Get_key         ;Carga la SK
		movlw   0x1f            ;Coloca los valores de la key cargada
                andwf   IC_P1,w
                movwf   P1KEY
                movlw   0x0f
                andwf   IC_P2,w
                movwf   P2KEY  

keyloaded	movlw   PK
		movwf   EEADR2
                movlw   KEYTMP
                call 	Move8
		call 	Move8
		return

ResetKey        movlw   0xff
                movwf   P1KEY
                movwf   P2KEY
       		return                     
;**************************************************************************************************
;* DECODE DATA IN SUPERENCRIPTION                                                                 *
;**************************************************************************************************
Decode
                btfss   IC_P2,7         ;Hay Supercriptacin?
                return                  ;Si NO -> volver
                call    LoadKeys
                clrf    FSR2
                decf    IC_LEN,W
                andlw   0xF8
                movwf   COUNTER
Decode_loop 
                movf    COUNTER,F
                btfsc   STATUS,Z
                return          
                call    LoadBuffer8
                call    Decrypt
                movlw   0x08    
                subwf   FSR2,F      
                subwf   COUNTER,F
                call    StoreBuffer8
                goto    Decode_loop                   

;**************************************************************************************************
Ldr_Loop  
                clrf    EEADRH2
                movf    LEDS,W
                btfss   CONTROL,1       ;Tipo de Led
                xorlw   0x0F
                movwf   PORTA
		
		;Leemos la cabecera del comando
                call    GetCommandHeader

                movlw   0xC1
                xorwf   IC_CLA,W
                btfsC   STATUS,Z
                goto    Ldr_Valid_CLA     ;Si Clase no es C1 enviar 6E00
		movlw	0x6E
		call	Send
		movlw	0x00
		call	Send
		goto	Ldr_Loop

Ldr_Valid_CLA	movf	IC_INS,w
		xorlw	0x20
		btfsc	STATUS,Z
		goto	Ldr_i20
		xorlw	0x22 ^ 0x20
		btfsc	STATUS,Z
		goto	Ldr_i22
		xorlw	0x24 ^ 0x22
		btfsc	STATUS,Z
		goto	Ldr_i24
		xorlw	0x26 ^ 0x24
		btfsc	STATUS,Z
		goto	Ldr_i26
		xorlw	0x28 ^ 0x26
		btfsc	STATUS,Z
		goto	Ldr_i28
		xorlw	0x7A ^ 0x28
		btfsc	STATUS,Z
		goto	Ldr_i7A
		movlw	0x6D           ;Comando desconocido
		call	Send
		movlw	0x00
		call	Send
		goto	Ldr_Loop
Ldr_CmdOK	movlw	0x90
		call	Send
		movlw	0x00
		call	Send
		goto	Ldr_Loop

Ldr_i20		movf	IC_INS,w
		call	Send
		call	Ldr_RdMem
		goto	Ldr_CmdOK
Ldr_i22		movf	IC_INS,w
		call	Send
		call	Ldr_WrMem
		goto	Ldr_CmdOK
Ldr_i24		movf	IC_INS,w
		call	Send
		call	Ldr_RdFlash
		goto	Ldr_CmdOK
Ldr_i26		movf	IC_INS,w
		call	Send
		call	Ldr_WrFlash
		goto	Ldr_CmdOK
Ldr_i28		movf	IC_INS,w
		call	Send
		call	Ldr_Exec
		goto	Ldr_CmdOK
Ldr_i7A		movf	IC_INS,w
		call	Send
		movlw	0x90
		call	Send
		movlw	0x00
		call	Send
		return
;***********************************************************************
;Lee un bloque de datos de la FLASH del 876 si P1 = 21h lee de la eeprom
;***********************************************************************
Ldr_RdMem
		call	GetAddr
		btfsc   STATUS,Z
		goto    Instr_20E

		movf	IC_LEN,W
		goto	FLASH_send
Instr_20E
		movf    IC_LEN,W
		goto    EEPROM_send

;Obtiene la direccion de lestura/escritura y la deja en EEADRH2:EEADR2
;Si la operacion es sobre la eeprom interna se devuelve Z=1
GetAddr
		movf    IC_P2,W         ;P2: Parte baja
		movwf	EEADR2
		movf    IC_P1,W		;P1: Parte alta de la direccin a leer
		movwf	EEADRH2
		btfss	EEADRH2,7
		goto	GetAddrEnd
		bcf	STATUS,C
		rlf	EEADR2,f
		rlf	EEADRH2,f
GetAddrEnd
		xorlw	0x21
		return


;*********************************************************************************
;* Escribe un bloque de datos en la FLASH del 876 si P1 = 21h escribe en la eeprom
;*********************************************************************************
Ldr_WrMem
                call    GetCommandData
                clrf    FSR2
		call	GetAddr
		btfsc	STATUS,Z
		goto	Instr_22E
instr_22_loop  
                call    Restore            ;Recibe un byte
                call	Wr_Memory
                incf    EEADR2,F
                btfsc   STATUS,Z
                incf    EEADRH2,F
                decfsz  IC_LEN,F
                goto    instr_22_loop
		return
Instr_22E
                call    Restore
                call    Wr_eeprom   
                incf    EEADR2,F
                decfsz  IC_LEN,F
                goto    Instr_22E
		return
;***********************************************
;* Leer la Flash de Programa    
;* P1:P2    Direccion
;* P3       Longitud
;***********************************************
Ldr_RdFlash
                movf    IC_P1,W         ;P1: Parte alta de la direccin a leer
                movwf   EEADRH2
                movf    IC_P2,W         ;P2: Parte baja
                movwf   EEADR2
instr_24_loop  
                call    Rd_PFlash       ;Lee valor de la Flash del 876
                bsf     STATUS,RP1      ;Select Bank 2
                movf    EEDATH,W
                bcf     STATUS,RP1      ;Back to Bank 0
                call    ChkSend         ;Y lo enva  
                bsf     STATUS,RP1      ;Select Bank 2
                movf    EEDATA,W
                bcf     STATUS,RP1      ;Back to Bank 0
                call    ChkSend         ;Y lo enva  
                incf    EEADR2,F
                btfsc   STATUS,Z
                incf    EEADRH2,F
                movf	IC_LEN,f
		btfss	STATUS,Z      
                goto    instr_24_loop
		return

;***********************************************
;* Escribir en la Flash de Programa
;* P1:P2    Direccion
;* P3       Longitud
;***********************************************
Ldr_WrFlash
		call    GetCommandData
		movf    IC_P1,W
		movwf   EEADRH2
		movf    IC_P2,W
		movwf   EEADR2
		clrf    FSR2
		rrf     IC_LEN,F
instr_26_loop  
		call    Restore         ;Recibe un byte
		bsf     STATUS,RP1      ;Select Bank 2
		movwf   EEDATH
		bcf     STATUS,RP1      ;Back to Bank 0
		call    Restore         ;Recibe un byte
		bsf     STATUS,RP1      ;Select Bank 2
		movwf   EEDATA
		bcf     STATUS,RP1      ;Back to Bank 0
		call	Wr_PFlash
		incf    EEADR2,F
		btfsc   STATUS,Z
		incf    EEADRH2,F
		decfsz  IC_LEN,F
		goto    instr_26_loop
		return

;***********************************************
;* Ejecutar el cdigo de la Flash de Programa
;* P1:P2    Direccion
;***********************************************
Ldr_Exec
		call    Instr_28_Exec
		clrf    PCLATH
		return
Instr_28_Exec               
		movf    IC_P1,W
		movwf   PCLATH
		movf    IC_P2,W
		movwf   PCL

;**************************************************************************************************
;* READ MEMORY FLASH/EXTERNAL                                                                     *
;**************************************************************************************************
;* EEADRH2:W = Address of Memory                                                                  *
;* W = Data Read                                                                                  *
;**************************************************************************************************
Rd_Memory       
                btfss   CONTROL,2
                goto    Rd_Flash
                goto    Rd_ExtMem
Rd_Memory_Next
                btfss   CONTROL,2
                goto    Rd_Flash_Next
                goto    Rd_ExtMem_Next
;**************************************************************************************************
;* WRITE MEMORY FLASH/EXTERNAL                                                                    *
;**************************************************************************************************
;* EEADRH2:EEADR2 = Address of Memory                                                             *
;* W = Data Written                                                                               *
;**************************************************************************************************
Wr_Memory       
		btfss   CONTROL,2
		goto    Wr_Flash
		goto    Wr_ExtMem

;**************************************************************************************************
;* READ EXTERNAL EEPROM MEMORY                                                                    *
;**************************************************************************************************
;* EEADRH2:W = Address of Memory                                                                  *
;* W = Data Read                                                                                  *
;**************************************************************************************************
Rd_ExtMem
                movwf   EEADR2
Rd_ExtMem2              
                call    i2c_controlW
                movf    EEADRH2,W
                call    i2c_write_byte
                movf    EEADR2,W
                call    i2c_write_byte
Rd_ExtMem_Next
                call    i2c_controlR
                call    i2c_read_byte
                call    StopBit
                movf    EEDATA2,W
                return
;**************************************************************************************************
;* WRITE EXTERNAL EEPROM MEMORY                                                                   *
;**************************************************************************************************
;* EEADRH2:EEADR2 = Address of Flash Memory                                                       *
;* W = Data Written                                                                               *
;**************************************************************************************************
Wr_ExtMem
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEDATA
                bcf     STATUS,RP1      ;Select Bank 0
Wr_ExtMem2              
                call    i2c_controlW
                movf    EEADRH2,W
                call    i2c_write_byte
                movf    EEADR2,W
                call    i2c_write_byte
                bsf     STATUS,RP1      ;Select Bank 2
                movf    EEDATA,W
                bcf     STATUS,RP1      ;Select Bank 0
                call    i2c_write_byte
                goto    StopBit

;**************************************************************************************************
;* READ FLASH MEMORY                                                                              *
;**************************************************************************************************
;* EEADRH2:w = Address of Memory                                                                  *
;* W = Data Read                                                                                  *
;**************************************************************************************************
Rd_Flash
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADR
                bcf     STATUS,RP1      ;Select Bank 0
		movlw	HIGH(BASE_DATOS) ;Mapearlo en el segundo 4K bloque
                addwf   EEADRH2,W
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADRH
		goto	Rd_Flash_Next

;******************************************************
;* READ PROGRAM FLASH MEMORY
;******************************************************
;* EEADRH2:EEADR2 = Address of Flash Memory
;* W = Data Read
;******************************************************
Rd_PFlash
                movf    EEADR2,W
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADR
                bcf     STATUS,RP1      ;Select Bank 0
                movf    EEADRH2,W
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADRH
Rd_Flash_Next
                bsf     STATUS,RP1      
                bsf     STATUS,RP0      ;Select Bank 3
                bsf     EECON1,EEPGD
                bsf     EECON1,RD
                nop                     ;Any instructions here are ignored as program
                nop                     ;memory is read in third cycle after BSF EECON1,RD
                bcf     STATUS,RP0      ;Select Bank 2
		movf	EEDATA,W
                incf    EEADR,F
                btfsc   STATUS,Z
                incf    EEADRH,F
		bcf     STATUS,RP1      ;Select Bank 0              
		return

;**************************************************************************************************
;* WRITE FLASH MEMORY                                                                             *
;**************************************************************************************************
;* EEADRH2:EEADR2 = Address of Flash Memory                                                       *
;* W = Data Written                                                                               *
;**************************************************************************************************
Wr_Flash
		bsf     STATUS,RP1      ;Select Bank 2
		movwf	EEDATA
		clrf	EEDATH
                bcf     STATUS,RP1      ;Select Bank 0
		movlw	HIGH(BASE_DATOS)
		addwf	EEADRH2,W
		goto	Wr_PFlash1

;******************************************************
;* WRITE PROGRAM FLASH MEMORY
;******************************************************
;* EEADRH2:EEADR2 = Address of Flash Memory
;* EEDATH:EEDATA = Data to Write
;******************************************************
Wr_PFlash
                movf    EEADRH2,W
Wr_PFlash1      bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADRH
                bcf     STATUS,RP1      ;Select Bank 0
                movf    EEADR2,W
                bsf     STATUS,RP1      ;Select Bank 2
                movwf   EEADR
                bsf     STATUS,RP0      ;Select Bank 3
                bsf     EECON1,EEPGD
                bsf     EECON1,WREN
                movlw   0x55
                movwf   EECON2
                movlw   0xAA
                movwf   EECON2
                bsf     EECON1,WR
                bcf     STATUS,RP0      
                bcf     STATUS,RP1      ;Select Bank 0
                btfss   PIR2,EEIF
	IFNDEF	SIMMODE
                goto    $-1
	ENDIF
                bcf     PIR2,EEIF
                bsf     STATUS,RP0
                bsf     STATUS,RP1      ;Select Bank 3
                bcf     EECON1,WREN
                bcf     STATUS,RP0      ;Select Bank 2
                bcf     STATUS,RP1      ;Select Bank 0
                return

;Guarda un bloque de datos en Buffer comparando.
;EEADRH2:EEADR2 Dir. inicial a comparar
;w: Num de datos a comparar
UpdateMem8	movlw	0x08
UpdateMem	
		movwf	TEMP+7
		movlw	BUFFER
		movwf	FSR
UpdateMemLoop
		movf	EEADR2,w
		call	Rd_Memory
		xorwf	INDF,w
		btfsc	STATUS,Z
			goto	NoMemChange
		movf	INDF,w
		call	Wr_Memory
		bsf	EcmEMM_CONTROL,5	;habilita bit 5 ( UpdateMem OK )
		bsf     LEDS,3          ;Activa el LED 3
NoMemChange
		incf	FSR,f
		incf	EEADR2,f
		btfsc	STATUS,Z
			incf	EEADRH2,f
		decfsz	TEMP+7,f
		goto	UpdateMemLoop
		return

;**************************************************************************************************
;* LOAD BUFFER                                                                                    *
;**************************************************************************************************
LoadBuffer8	movlw	0x08
LoadBuffer	movwf	TEMP+7
                movlw   BUFFER
                movwf   FSR
LoadBuffer_loop
                call    Restore
                movwf   INDF
                incf    FSR,F
                decfsz	TEMP+7,f           
                goto    LoadBuffer_loop
                return

;**************************************************************************************************
;* STORE BUFFER                                                                                   *
;**************************************************************************************************
StoreBuffer8	movlw	0x08
StoreBuffer
		movwf	TEMP+7
                movlw   BUFFER
                movwf   FSR
StoreBuffer_loop
                movf    INDF,W
                call    Store
                incf    FSR,F
                decfsz	TEMP+7,f          
                goto    StoreBuffer_loop
                return


;**************************************************************************             
Log
		btfss   CONTROL,4	;Log activo?
			return

		movlw	LOW(LOGCOUNTER)
		call	Rd_eeprom                   
		movwf	DUMMY4
		movwf	DUMMY6
		movlw	LOW(LOGCOUNTER+1)                          
		call	Rd_eeprom                   
		movwf	DUMMY3
		movwf	DUMMY5
		movlw	LOW(MAXLOG)                          
		call	Rd_eeprom
		movwf	DUMMY2
		movlw	LOW(MAXLOG+1)                          
		call	Rd_eeprom
		movwf	DUMMY1
	
		movlw	0x05
		btfss	IC_INS,1
		addwf	IC_LEN,W
		addwf	DUMMY5,F
		btfsc   STATUS,C
		incf	DUMMY6,F           
		movf   	DUMMY2,W
		subwf  	DUMMY6,W                        
		btfss	STATUS,Z
		goto    Full_log
		movf	DUMMY1,W                        
		subwf   DUMMY5,W                        
Full_log	btfsc	STATUS,C
		goto	Log_full              

		movlw	0x04
		movwf	COUNTER
		movlw	IC_CLA
		movwf	FSR
		movlw   LOW(CONFIGLOG)  ;Comprueba la mscara
		movwf	DUMMY2
LogMaskLoop
		movf	DUMMY2,w
		call    Rd_eeprom
		andwf	INDF,W
		movwf	DUMMY1
		incf	DUMMY2,f
		movf	DUMMY2,w
		call    Rd_eeprom
		xorwf   DUMMY1,W
		btfss   STATUS,Z
		return
		incf	FSR,f
		incf	DUMMY2,f
		decfsz	COUNTER,f
		goto	LogMaskLoop

                movlw	LOW(CONFIGLOG+8)
		call    Rd_eeprom       ;Leer Longitud mxima
		xorlw	0xff
		addwf	INDF,w
		btfsc	STATUS,C
		return

		movlw	LOW(CONFIGLOG+9)
		call    Rd_eeprom       ;Leer Longitud mnima
                subwf   INDF,w
                btfss   STATUS,C
                return

		movlw	LOW(LOG_FILTER)
		movwf	DUMMY2
LoopCheckLogFilter:
		movf	DUMMY2,w
		call    Rd_eeprom       ;Filtra instrucciones no deseadas
                xorwf	IC_INS,w
                btfsc	STATUS,Z
                return
		incf	DUMMY2,f
		movlw	LOW(LOG_FILTER_END)
		subwf	DUMMY2,w
		skpc
		goto	LoopCheckLogFilter

                movlw   LOW(POSLOG+1)
                call    Rd_eeprom
                addwf   DUMMY3,W
		btfsc   STATUS,C
		incf	DUMMY4,F
                movwf   EEADR2
                movlw   LOW(POSLOG)
                call    Rd_eeprom
		addwf	DUMMY4,W
                movwf   EEADRH2

                bsf     LEDS,2          ;Led de datos en log
                movlw   IC_CLA
                movwf   FSR
Log_loop1    
                movf    INDF,W
                call    StoreLog
                incf    FSR,f
                btfsc   FSR,3
                goto    Log_loop1
                btfsc   IC_INS,1      ;Si es from CARD to CAM termino
                goto    End_Log

                clrf    FSR2
                movf    IC_LEN,W
                movwf   COUNTER
Log_loop2   
                call    Restore         ;Datos
                call    StoreLog
                decfsz  COUNTER,f
                goto    Log_loop2

;**************************************************************************
End_Log         
                movlw   LOW(LOGCOUNTER)
                movwf   EEADR2
		movf	DUMMY6,W
                call    Wr_eeprom
                movlw   LOW(LOGCOUNTER+1)
                movwf   EEADR2
		movf	DUMMY5,W
                call    Wr_eeprom
                return

StoreLog
                call	Wr_Memory
                incfsz	EEADR2,F
                return
                incf	EEADRH2,F
                return

Log_full
                bsf	LEDS,3          ;Led de Log lleno
                return

;**************************************************************************************************
;Rutina de encriptacin SECA
;DUMMY3 es i apunta al elemento de la key que se est procesando (0x00..0x0f)
;DUMMY1 es la constante C
;BUFFER[8] contiene los datos a encriptar
;PK[8],SK[8] contiene la clave primaria y secundaria respectivamente
;**************************************************************************************************
Encrypt
                clrf    DUMMY1          ;C=0
                clrf    DUMMY3          ;i=1
Encrypt_round       
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                incf    DUMMY3,f        ;i=i+1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                incf    DUMMY3,f        ;i=i+1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                incf    DUMMY3,f        ;i=i+1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                movlw   3
                subwf   DUMMY3,f        ;i=i-3
                call    crypt1
                incf    DUMMY3,f        ;i=i+1
                call    crypt2
                movf    DUMMY1,W        ;C -> W
                xorlw   0x0F            ;
                btfsc   STATUS,Z        ;Si C=15 retornar 
                return                  ;Encriptacin terminada
                movlw   BUFFER
                movwf   EEADR2
                movlw   BUFFER+4
                call   Swap4           ;Swap de d[0]..d[3] con d[4]..d[7]
                incf    DUMMY1,f        ;C=C+1
                btfsc   DUMMY3,4        ;Si i>15
                clrf    DUMMY3          ;i=0
                goto    Encrypt_round   ;Siguiente iteracin
;**************************************************************************************************
;Rutina de desencriptacin SECA
;DUMMY3 apunta al elemento de la key que se est procesando (0x00..0x0f)
;DUMMY1 es la constante C
;BUFFER[8] contiene los datos a encriptar
;PK[8],SK[8] contiene la clave primaria y secundaria respectivamente
;**************************************************************************************************
Decrypt     
                clrf    DUMMY3
                clrf    DUMMY1
Decrypt_loop
                call    InitKey         ;K[i]=K[i] XOR T1[K[i-1] XOR K[i+1] XOR C]
                incf    DUMMY3,f        ;i=i+1 
                movf    DUMMY3,W
                andlw   0x03
                btfsc   STATUS,Z
                incf    DUMMY1,f        ;Cada 4 iteraciones del bucle incrementa la constante C
                btfss   DUMMY3,6
                goto    Decrypt_loop    ;Hacer 16*4 iteraciones

                movlw   .15             ;C=15
                movwf   DUMMY1
                movlw   .12                 ;i=13
                movwf   DUMMY3
Decrypt_round       
                call    crypt1
                call    crypt2

                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
                decf    DUMMY3,F        ;i=i-1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
                decf    DUMMY3,F        ;i=i-1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
                decf    DUMMY3,F        ;i=i-1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
                movf    DUMMY1,F
                btfsc   STATUS,Z        ;Si C=0 retornar
                return

                movlw   BUFFER
                movwf   EEADR2
                movlw   BUFFER+4
                call   Swap4           ;Swap de d[0]..d[3] con d[4]..d[7]
                decf    DUMMY1,f        ;C=C-1
                movlw   0xFC
                addwf   DUMMY3,f        ;i=i-4
                movlw   .12
                btfsc   DUMMY3,7        ;Si i se ha vuelto negativo
                movwf   DUMMY3          ;lo pone de nuevo a 12
                goto    Decrypt_round
;**************************************************************************************************
crypt1
                call    ekey            ;W = K[i] XOR d5
                xorwf   BUFFER+4,W          
                call    Tabla1
                movwf   TEMP+0          ;TEMP+0=T1[W]
                incf    DUMMY3,F        ;i=i+1
                call    ekey            ;W = K[i] XOR d6
                xorwf   BUFFER+5,W
                call    Tabla1
                movwf   TEMP+1          ;TEMP+1=T1[W]
                incf    DUMMY3,F        ;i=i+1
                call    ekey            ;W = K[i] XOR d7
                xorwf   BUFFER+6,W
                call    Tabla1
                movwf   TEMP+2          ;TEMP+2=T1[W]
                incf    DUMMY3,F        ;i=i+1
                call    ekey            ;W = K[i] XOR d8
                xorwf   BUFFER+7,W
                call    Tabla1
                movwf   TEMP+3          ;TEMP+3=T1[W]
                return
;**************************************************************************************************
crypt2              
                xorwf   TEMP+0,f        ;d5=d5 XOR d8
                swapf   TEMP+3,W
                addwf   TEMP+2,W        ;W=~d8+d7 
                call    Tabla2          ;W=T2[W]
                movwf   TEMP+2          ;TEMP+2=T2[W]
                xorwf   TEMP+3,f        ;d[7]=d[7] XOR d[6]
                swapf   TEMP+2,W
                addwf   TEMP+1,W
                call    Tabla2
                movwf   TEMP+1          ;d[5]=T2[~d[6]+d[5]]
                xorwf   TEMP+2,f        ;d[6]=d[6] XOR d[5]
                swapf   TEMP+1,W
                addwf   TEMP+0,W
                call    Tabla2
                movwf   TEMP+0              ;d[4]=T2[~d[5]+d[4]]
                xorwf   TEMP+1,f            ;d[5]=d[5] XOR d[4]
                swapf   TEMP+0,W
                addwf   TEMP+3,W
                call    Tabla1
                movwf   TEMP+3              ;d[7]=T1[~d[4]+d[7]]
                xorwf   TEMP+0,f            ;d[4]=d[4] XOR d[7]
                swapf   TEMP+3,W
                addwf   TEMP+2,W
                call    Tabla1
                movwf   TEMP+2              ;d[6]=T1[~d[7]+d[6]]
                xorwf   TEMP+3,f            ;d[7]=d[7] XOR d[6]
                swapf   TEMP+2,W
                addwf   TEMP+1,W
                call    Tabla1
                movwf   TEMP+1              ;d[5]=T1[~d[6]+d[5]]
                xorwf   TEMP+2,f            ;d[6]=d[6] XOR d[5]
                movf    TEMP+0,W
                xorwf   TEMP+1,f            ;d[5]=d[5] XOR d[4]

                movf    TEMP+1,W
                call    Tabla2
                xorwf   BUFFER+0,f      ;d[0]=d[0] XOR T2[d[5]]
                movf    TEMP+3,W
                call    Tabla2
                xorwf   BUFFER+1,f      ;d[1]=d[1] XOR T2[d[7]]
                movf    TEMP+0,W
                call    Tabla2
                xorwf   BUFFER+2,f      ;d[2]=d[2] XOR T2[d[4]] 
                movf    TEMP+2,W
                call    Tabla2
                xorwf   BUFFER+3,f      ;d[3]=d[3] XOR T2[d[6]]
                return
;**************************************************************************************************
;* K[i]=K[i] XOR T1[K[i-1] XOR K[i+1] XOR C]
InitKey       
                incf    DUMMY3,W
                call    ekeyW
                movwf   DUMMY2          ;K[i+1]
                decf    DUMMY3,W
                call    ekeyW    
                xorwf   DUMMY2,f        ;K[i+1] XOR K[i-1]
                call    ekey            ;No usa el resultado, pero hace que FSR apunte al elemento indicado por 0x0f
                movf    DUMMY2,W   
                xorwf   DUMMY1,W        ;K[i+1] XOR K[i-1] XOR C
                call    Tabla1          ;T1[K[i+1] XOR K[i-1] XOR C]
                xorwf   INDF,f          ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                return
;**************************************************************************************************
;* W = K[i]
ekey        
                movf    DUMMY3,W        ;i -> W
ekeyW       
                andlw   0x0F            ;Devuelve el elemento apuntado en W. El AND controla el wrap (por si el indice mayor de 0x0f)
                addlw   PK              ;La key est almacenada en PK
                movwf   FSR
                movf    INDF,W
                return

;**************************************************************************************************
;* STORE W->[FSR2] 256                                                                            *
;**************************************************************************************************
Store
                movwf   0x7F
                movf    FSR,W
                movwf   0x7E
                movlw   0x50
                subwf   FSR2,W
                btfss   STATUS,C
                goto    Store_1
                movlw   0xB0
                subwf   FSR2,W
                btfss   STATUS,C
                goto    Store_2
Store_3
                movlw   0xE0
                addwf   FSR2,W
                movwf   FSR
                bsf     STATUS,IRP
                movf    0x7F,W
                movwf   INDF
                bcf     STATUS,IRP
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return
Store_2
                movlw   0xC0
                addwf   FSR2,W
                movwf   FSR
                bsf     STATUS,IRP
                movf    0x7F,W
                movwf   INDF
                bcf     STATUS,IRP
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return
Store_1             
                movlw   0xA0
                addwf   FSR2,W
                movwf   FSR
                movf    0x7F,W
                movwf   INDF
                bcf     STATUS,IRP
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return

;**************************************************************************************************
;* RESTORE [FSR2]->W 256                                                                          *
;**************************************************************************************************
Restore
                movf    FSR,W
                movwf   0x7E
                movlw   0x50
                subwf   FSR2,W
                btfss   STATUS,C
                goto    Restore_1
                movlw   0xB0
                subwf   FSR2,W
                btfss   STATUS,C
                goto    Restore_2
Restore_3
                movlw   0xE0
                addwf   FSR2,W
                movwf   FSR
                bsf     STATUS,IRP
                movf    INDF,W
                movwf   0x7F
                bcf     STATUS,IRP
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return
Restore_2
                movlw   0xC0
                addwf   FSR2,W
                movwf   FSR
                bsf     STATUS,IRP
                movf    INDF,W
                movwf   0x7F
                bcf     STATUS,IRP
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return
Restore_1               
                movlw   0xA0
                addwf   FSR2,W
                movwf   FSR
                bcf     STATUS,IRP
                movf    INDF,W
                movwf   0x7F
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return

;**************************************************************************************************
; Rutinas de gestion del PPV
;**************************************************************************************************

#ifndef COMPILE_873_VERSION

BuscarPPV	; Vamos a utilizar DUMMY 1,2 para el evento a buscar, si lo envontramos en DUMMY 3
		; devolvemos el identificador de sesion

		clrf	DUMMY3
		movlw	LOW(PPVTBL)	; Empiece de la tabla
		movwf	FSR
		
BuscarPPVLoop	
		sublw	PPVMAXBYTES
		bcf	STATUS,IRP	;Select Bank 0
		addlw	LOW(PPVTBL)
		btfsc	STATUS, Z
		return		
		bsf	STATUS,IRP	;Select Bank 2 
		movf	INDF, W
		xorwf	DUMMY1, W
		btfss	STATUS, Z	; Es igual el primer byte del PPVID
		goto	BuscarPPVcont1
		incf	FSR,f
		movf	INDF, W
		xorwf	DUMMY2, W
		btfss	STATUS, Z	; Es igual el segundo byte del PPVID
		goto	BuscarPPVcont2
		incf	FSR,f		; Lo hemos encotrado devolver en DUMMY3 el ID de sesion
		movf	INDF, W
		bcf	STATUS,IRP	;Select Bank 0
		movwf	DUMMY3
		return

BuscarPPVcont1	incf	FSR,f

BuscarPPVcont2	incf	FSR,f
		incf	FSR,f 
		movf	FSR, W
		goto 	BuscarPPVLoop
		
AltaPPV		; Aqui buscamos un evento si lo encontramos reescribimos la sesion, si no, lo damos de alta.
		; Lo mismo que antes en DUMMY1,2 estara el EventID y en 4 estara el Id de la sesion
		; retorna 0x01 si el evento ya estaba dado de alta y 0x00 si es nuevo

		call 	BuscarPPV
		movf	DUMMY3, W
		btfsc	STATUS, Z
		goto	AltaPPVnew
		movf	DUMMY4, W	; Ya estaba reescribimos la sesion ID
		bsf	STATUS,IRP	;Select Bank 2 
		movwf	INDF
		bcf	STATUS,IRP	;Select Bank 0
		retlw	0x01
		
AltaPPVnew	
		bsf	STATUS,RP1	;Select Bank 2 
		movf	PPVPOS,W
		addlw	0x3		; Calculamos la posicion
		movwf	PPVPOS
		incf	PPVCNT,f
		movf	PPVCNT,w
		sublw	PPVMAX
		btfss	STATUS, Z
		goto	AltaPPV1
		clrf	PPVPOS	; vuelvo a empezar
		clrf	PPVCNT
		goto	AltaPPVnew	
AltaPPV1	movf	PPVPOS, W
		addlw	LOW(PPVTBL-0x03)
		movwf	FSR

		; Damos de alta el 1er byte del PPVID
		bcf	STATUS,RP1	;Select Bank 0
		movf	DUMMY1, W
		bsf	STATUS,IRP	;Select Bank 2 
		movwf	INDF
		incf	FSR,f

		; Damos de alta el 2do byte del PPVID
		movf	DUMMY2, W
		movwf	INDF
		incf	FSR,f
		
		; Damos de alta el Id de sesion
		movf	DUMMY4, W
		movwf	INDF
		incf	FSR,f
		
		bcf	STATUS,IRP	;Select Bank 0
		retlw	0x00


ClearPPV
		bsf	STATUS,RP1	;Select Bank 2 
		clrf	PPVCNT	
		clrf	PPVPOS
		bcf	STATUS,RP1	;Select Bank 0
		bsf	STATUS,IRP	;Select Bank 2 
		movlw	LOW(PPVTBL)	; Empiece de la tabla
		movwf	FSR
		movlw	PPVMAXBYTES
		movwf	DUMMY3
ClearPPVLoop
		clrf	INDF
		incf	FSR,f
		decfsz	DUMMY3,f
		goto	ClearPPVLoop
		bcf	STATUS,IRP	;Select Bank 0
		return

#else

BuscarPPV	; Vamos a utilizar DUMMY 1,2 para el evento a buscar, si lo envontramos en DUMMY 3
		; devolvemos el identificador de sesion

		clrf	DUMMY3
		movlw	LOW(PPVTBL)	; Empiece de la tabla
		movwf   COUNTER
				
BuscarPPVLoop	
		sublw	PPVMAXBYTES
		xorlw	LOW(PPVTBL)
		btfsc	STATUS, Z
		return	
		movf	COUNTER,W 
		call	Rd_eeprom
		xorwf	DUMMY1, W
		btfss	STATUS, Z	; Es igual el primer byte del PPVID
		goto	BuscarPPVcont1
		incf	COUNTER,f
		movf	COUNTER,W 
		call	Rd_eeprom
		xorwf	DUMMY2, W
		btfss	STATUS, Z	; Es igual el segundo byte del PPVID
		goto	BuscarPPVcont2
		incf	COUNTER,f
		movf	COUNTER,W 
		call	Rd_eeprom
		movwf	DUMMY3
		return

BuscarPPVcont1	incf	COUNTER,f 

BuscarPPVcont2	incf	COUNTER,f
		incf	COUNTER,f
		movf	COUNTER,W
		goto 	BuscarPPVLoop
		
AltaPPV		; Aqui buscamos un evento si lo encontramos reescribimos la sesion, si no, lo damos de alta.
		; Lo mismo que antes en DUMMY1,2 estara el EventID y en 4 estara el Id de la sesion

		bcf	STATUS,IRP	;Select Bank 0
		call 	BuscarPPV
		btfsc	STATUS, Z
		goto	AltaPPVnew
		movf	COUNTER,W
		movwf	EEADR2
		movf	DUMMY4, W	; Ya estaba reescribimos la sesion ID	
		call	Wr_eeprom
		retlw	0x01
		
AltaPPVnew	
		movf	PPVPOS,W
		addlw	0x3		; Calculamos la posicion
		movwf	PPVPOS
		incf	PPVCNT,f
		movf	PPVCNT,w
		sublw	PPVMAX
		btfss	STATUS, Z
		goto	AltaPPV1
		clrf	PPVPOS	; vuelvo a empezar
		clrf	PPVCNT
		goto	AltaPPVnew	
AltaPPV1	movf	PPVPOS, W
		addlw	LOW(PPVTBL-0x03)
		movwf	EEADR2
		movf	DUMMY1, W
		call	Wr_eeprom;
		incf	EEADR2,f
		movf	DUMMY2, W
		call	Wr_eeprom;
		incf	EEADR2,f
		; Damos de alta el Id de sesion
		movf	DUMMY4, W
		call	Wr_eeprom;
		incf	EEADR2,f
		bcf	STATUS,IRP	;Select Bank 0
		retlw	0x00

ClearPPV
		clrf	PPVCNT	
		clrf	PPVPOS
		return

#endif

;****************************************************************
SendInfoLine
                movlw   0x00
                call    ChkSend
                movlw   0x40        ;Envia prov. 40 para evitar chequeos
                call    ChkSend
                btfss   CONTROL,3       ;AutoUpdate ?
                goto    ShowAuto
                movlw   'P'
                call    ChkSend                
                movlw   'R'
                call    ChkSend                
                movlw   'O'
                call    ChkSend                
                movlw   'T'
                call    ChkSend                
                goto    ShowNext1
ShowAuto
                movlw   'A'
                call    ChkSend                
                movlw   'U'
                call    ChkSend                
                movlw   'T'
                call    ChkSend                
                movlw   'O'
                call    ChkSend                
ShowNext1
                movlw   ' '
                call    ChkSend
                btfss   CONTROL2,6       ;Se encontro EEPROM externa
                goto    ShowAccess
                movlw   'N'
                call    ChkSend                
                movlw   'E'
                call    ChkSend                
                movlw   'E'
                call    ChkSend        
                goto    ShowNext2       
ShowAccess                              
                btfss   CONTROL,2       ;Modo SingleChip?
                goto    ShowInternal
                movlw   'E'
                call    ChkSend                
                movlw   'X'
                call    ChkSend                
                movlw   'T'
                call    ChkSend        
                goto    ShowNext2       
ShowInternal                
                movlw   'I'
                call    ChkSend                
                movlw   'N'
                call    ChkSend                
                movlw   'T'
                call    ChkSend        
ShowNext2               
                movlw   ' '
                call    ChkSend
                
                movlw   LOW(LOGCOUNTER)     ;Leo el contador de datos (LOW)
                call    Rd_eeprom
                movwf   DUMMY1
                movlw   LOW(LOGCOUNTER+1)
                call    Rd_eeprom        ;Leo el contador de datos (HIGH)
                movwf   DUMMY2
                
                movf    DUMMY1,W
                btfss   STATUS,Z
                goto    LogCNot0
                movf    DUMMY2,W
                btfss   STATUS,Z
                goto    LogCNot0
                movlw   'E'
                call    ChkSend                
                movlw   'M'
                call    ChkSend                
                movlw   'P'
                call    ChkSend        
                movlw   ' '
                call    ChkSend        
                goto    ShowNext3
LogCNot0
                movf    DUMMY1,W
                xorlw   0x04
                btfsc   STATUS,Z
                goto    LogCFull
                movf    DUMMY1,W
                andlw   0x0F
                call   	Tabla_conv
                call    ChkSend
                swapf   DUMMY2,W
                andlw   0x0F
                call   	Tabla_conv
                call    ChkSend
                movf    DUMMY2,W                
                andlw   0x0F                
                call   	Tabla_conv
                call    ChkSend        
                movlw   ' '
                call    ChkSend
                goto    ShowNext3
LogCFull                
                movlw   'F'
                call    ChkSend                
                movlw   'U'
                call    ChkSend                
                movlw   'L'
                call    ChkSend        
                movlw   ' '
                call    ChkSend        
ShowNext3
                movlw   VER_MAJOR
                call    ChkSend
                movlw   VER_MINOR
                call    ChkSend
                movlw   ' '
                call    ChkSend
                movlw   0x00
                call    ChkSend
                movlw   0x12
                call    ChkSend
                movlw   0x43
                call    ChkSend
                movlw   0x17
                call    ChkSend
                movlw   high DATE
                call    ChkSend
                movlw   low  DATE
                call    ChkSend
		return
;**************************************************************************************************
;Devuelve el valor de Tabla1 del algoritmo de SECA que corresponde al valor contenido en W
Tabla1      
                call    Tabla12
		bcf     PCLATH,0
                bcf     PCLATH,1
                bcf     PCLATH,2
                return
Tabla12             
                bcf     PCLATH,0
                bsf     PCLATH,1        ;Tabla1 en 0x0600
                bsf     PCLATH,2
                movwf   PCL             ;Absolute addressing
;**************************************************************************************************
;Devuelve el valor de Tabla2 del algoritmo de SECA que corresponde al valor contenido en W
Tabla2
                call    Tabla22
                bcf     PCLATH,0
                bcf     PCLATH,1
                bcf     PCLATH,2
                return
Tabla22         
                bsf     PCLATH,0     
                bsf     PCLATH,1        ;Tabla 2 en 0x0700
                bsf     PCLATH,2
                movwf   PCL             ;Absolute addressing

;Esta funcion debe estar en el banco 0

Tabla_conv
	addlw	-(0x0a)
	skpnc
	addlw	'A'-('0'+0x0a)
	addlw	'0'+0x0a
	return

;
; Codigo de tablas para las routinas del algoritmo de SECA
;

Tablas
                ORG     0x0600
; TABLA1
                DT  0x2A,0xE1,0x0B,0x13,0x3E,0x6E,0x32,0x48,0xD3,0x31,0x08,0x8C,0x8F,0x95,0xBD,0xD0
                DT  0xE4,0x6D,0x50,0x81,0x20,0x30,0xBB,0x75,0xF5,0xD4,0x7C,0x87,0x2C,0x4E,0xE8,0xF4
                DT  0xBE,0x24,0x9E,0x4D,0x80,0x37,0xD2,0x5F,0xDB,0x04,0x7A,0x3F,0x14,0x72,0x67,0x2D
                DT  0xCD,0x15,0xA6,0x4C,0x2E,0x3B,0x0C,0x41,0x62,0xFA,0xEE,0x83,0x1E,0xA2,0x01,0x0E
                DT  0x7F,0x59,0xC9,0xB9,0xC4,0x9D,0x9B,0x1B,0x9C,0xCA,0xAF,0x3C,0x73,0x1A,0x65,0xB1
                DT  0x76,0x84,0x39,0x98,0xE9,0x53,0x94,0xBA,0x1D,0x29,0xCF,0xB4,0x0D,0x05,0x7D,0xD1
                DT  0xD7,0x0A,0xA0,0x5C,0x91,0x71,0x92,0x88,0xAB,0x93,0x11,0x8A,0xD6,0x5A,0x77,0xB5
                DT  0xC3,0x19,0xC1,0xC7,0x8E,0xF9,0xEC,0x35,0x4B,0xCC,0xD9,0x4A,0x18,0x23,0x9F,0x52
                DT  0xDD,0xE3,0xAD,0x7B,0x47,0x97,0x60,0x10,0x43,0xEF,0x07,0xA5,0x49,0xC6,0xB3,0x55
                DT  0x28,0x51,0x5D,0x64,0x66,0xFC,0x44,0x42,0xBC,0x26,0x09,0x74,0x6F,0xF7,0x6B,0x4F
                DT  0x2F,0xF0,0xEA,0xB8,0xAE,0xF3,0x63,0x6A,0x56,0xB2,0x02,0xD8,0x34,0xA4,0x00,0xE6
                DT  0x58,0xEB,0xA3,0x82,0x85,0x45,0xE0,0x89,0x7E,0xFD,0xF2,0x3A,0x36,0x57,0xFF,0x06
                DT  0x69,0x54,0x79,0x9A,0xB6,0x6C,0xDC,0x8B,0xA7,0x1F,0x90,0x03,0x17,0x1C,0xED,0xD5
                DT  0xAA,0x5E,0xFE,0xDA,0x78,0xB0,0xBF,0x12,0xA8,0x22,0x21,0x3D,0xC2,0xC0,0xB7,0xA9
                DT  0xE7,0x33,0xFB,0xF1,0x70,0xE5,0x17,0x96,0xF8,0x8D,0x46,0xA1,0x86,0xE2,0x40,0x38
                DT  0xF6,0x68,0x25,0x16,0xAC,0x61,0x27,0xCB,0x5B,0xC8,0x2B,0x0F,0x99,0xDE,0xCE,0xC5
; TABLA 2
                DT  0xBF,0x11,0x6D,0xFA,0x26,0x7F,0xF3,0xC8,0x9E,0xDD,0x3F,0x16,0x97,0xBD,0x08,0x80
                DT  0x51,0x42,0x93,0x49,0x5B,0x64,0x9B,0x25,0xF5,0x0F,0x24,0x34,0x44,0xB8,0xEE,0x2E
                DT  0xDA,0x8F,0x31,0xCC,0xC0,0x5E,0x8A,0x61,0xA1,0x63,0xC7,0xB2,0x58,0x09,0x4D,0x46
                DT  0x81,0x82,0x68,0x4B,0xF6,0xBC,0x9D,0x03,0xAC,0x91,0xE8,0x3D,0x94,0x37,0xA0,0xBB
                DT  0xCE,0xEB,0x98,0xD8,0x38,0x56,0xE9,0x6B,0x28,0xFD,0x84,0xC6,0xCD,0x5F,0x6E,0xB6
                DT  0x32,0xF7,0x0E,0xF1,0xF8,0x54,0xC1,0x53,0xF0,0xA7,0x95,0x7B,0x19,0x21,0x23,0x7D
                DT  0xE1,0xA9,0x75,0x3E,0xD6,0xED,0x8E,0x6F,0xDB,0xB7,0x07,0x41,0x05,0x77,0xB4,0x2D
                DT  0x45,0xDF,0x29,0x22,0x43,0x89,0x83,0xFC,0xD5,0xA4,0x88,0xD1,0xF4,0x55,0x4F,0x78
                DT  0x62,0x1E,0x1D,0xB9,0xE0,0x2F,0x01,0x13,0x15,0xE6,0x17,0x6A,0x8D,0x0C,0x96,0x7E
                DT  0x86,0x27,0xA6,0x0D,0xB5,0x73,0x71,0xAA,0x36,0xD0,0x06,0x66,0xDC,0xB1,0x2A,0x5A
                DT  0x72,0xBE,0x3A,0xC5,0x40,0x65,0x1B,0x02,0x10,0x9F,0x3B,0xF9,0x2B,0x18,0x5C,0xD7
                DT  0x12,0x47,0xEF,0x1A,0x87,0xD2,0xC2,0x8B,0x99,0x9C,0xD3,0x57,0xE4,0x76,0x67,0xCA
                DT  0x3C,0xFB,0x90,0x20,0x14,0x48,0xC9,0x60,0xB0,0x70,0x4E,0xA2,0xAD,0x35,0xEA,0xC4
                DT  0x74,0xCB,0x39,0xDE,0xE7,0xD4,0xA3,0xA5,0x04,0x92,0x8C,0xD9,0x7C,0x1C,0x7A,0xA8
                DT  0x52,0x79,0xF2,0x33,0xBA,0x1F,0x30,0x9A,0x00,0x50,0x4C,0xFF,0xE5,0xCF,0x59,0xC3
                DT  0xE3,0x0A,0x85,0xB3,0xAE,0xEC,0x0B,0xFE,0xE2,0xAB,0x4A,0xAF,0x69,0x6C,0x2C,0x5D

;****************************************
; ZONA 2 de codigo.
;****************************************
		ORG 	0x0800
SECA_Init
		clrf	IC_INS
		clrf	reg80
; Inicializamos PPV
		xcall 	ClearPPV


		;bsf	CONTROL2,3		;Activar ins. protegidas
TX9000      
                movlw   0x90			;Load 90h code
TXxx00
		call    b1_Send			;Send to CAM
		movlw   0x00			;Load 00h code
SendMain	call    b1_Send			;Send to CAM
Main  
		clrf    EEADRH2
		movf    LEDS,W
		btfss   CONTROL,1       ;Tipo de Led
			xorlw   0x0F
		movwf   PORTA

;Si la instruccion anterior tuvo error no actualiza PREVINS
;a no ser que sea la ins 3C
		movf	IC_INS,W
		movwf	PREVINS
		xorlw	0x3c
		btfsc	STATUS,Z
		goto	GetHeader
		btfsc	CONTROL2,1
		clrf	PREVINS
		
;Leemos la cabecera del comando
GetHeader
		bcf	CONTROL2,1
		xcall	GetCommandHeader

		movlw   0xC1
		xorwf   IC_CLA,W
		btfss   STATUS,Z
		goto    Invalid_CLA     ;Si Clase no es C1 enviar 6E00
		
		movf	IC_LEN,W
		btfss	STATUS,Z	;Si LEN==0
		goto	CheckLENMax
		btfsc	IC_INS,1	;solo valido si es cam->card
		goto	TX6D00		;Send 6D00 else skip and devolver todas FF + 6D00
		goto	AckSent		;Si len=0 no hay ack
CheckLENMax
		sublw	LenMAX
		btfss	STATUS,C	;If LEN > 5F send STATUS BYTE 6700
		goto	TX6700		
		movf	IC_INS,W
		call	b1_Send		;Envia el ACK
AckSent
		btfss   CONTROL2,3	;Comprobar Flag de Actualizacin
		goto    Normal_ins		

		movfw	IC_INS	;Instrucciones especiales de actualizacion
		xorlw	0x20		;Se comportan al reves que las normales
		btfsc	STATUS,Z	;Por eso se tratan por separado
			goto	Instr_20
		xorlw	(0x22 ^ 0x20)
		btfsc	STATUS,Z
			goto	Instr_22
		xorlw	(0x24 ^ 0x22)
		btfsc	STATUS,Z
			goto	Instr_24
		xorlw	(0x26 ^ 0x24)
		btfsc	STATUS,Z
			goto	Instr_26
		xorlw	(0x28 ^ 0x26)
		btfsc	STATUS,Z
			goto	Instr_28
Normal_ins
		movf	IC_INS,w
		xorlw	0x40		;Activa insprotegidas
		btfss	STATUS,Z
		goto	Normal_ins_2
		movf	IC_P1,w
		btfss	STATUS,Z
		goto	Normal_ins_2
		movf	IC_P2,w 
		xorlw	0x80 
		btfss	STATUS,Z
		goto	Normal_ins_2
		movf	IC_LEN,w 
		btfss	STATUS,Z 
		goto	Normal_ins_2 
		bsf	CONTROL2,3	; INS ACTIVADAS
		movlw	0x40
		call	b1_Send
		goto    TX9000
Normal_ins_2
		btfsc	IC_INS,1
			goto	cardcam_ins
		xcall	GetCommandData	;Es CAM->CARD. Leer datos
	
cardcam_ins
		xcall	Log

		movlw   .26             ;Hay 26 instrucciones
		movwf   TEMP+1          ;contador de instrucciones
Comm_scan   
		movfw	TEMP+1
		addlw	LOW(CmdList-1)	;offset w internal EEPROM
		call	b1_Rd_eeprom	;Lee el codigo de instruccion
		xorwf	IC_INS,W
		btfsc	STATUS,Z	;Si es el que se ha recibido
		goto	ValidInstr	;lo procesa
		decfsz	TEMP+1,f	;Decrementa la variable del bucle
		goto	Comm_scan	;y si no es cero vuelve a hacer otra iteracin
		goto	ValidCheck

ValidInstr
		movf	TEMP+1,w
		sublw	0x03		;Los 3 primeros comandos (0a y 0e) no chequean proveedor
		btfsc	STATUS,C
		goto	NoCheckPrv
ValidCheck
		xcall	Chk_Provider
		btfss	STATUS,C	;if provider exist skip...
		goto	PROV_ERROR	;...else send todas FF + 9004
NoCheckPrv
		movf	TEMP+1,f
		btfss	STATUS,Z
		goto	DoInstr	

;Comando desconocido
		
		bsf	LEDS,2			;Activamos el led 2
		btfsc	IC_INS,1
			call	b1_Send_FF
		goto	TX6D00		;Si no se conoce la instr. devolver todas FF + 6D00 

Invalid_CLA             
                bsf     LEDS,2          ;Activamos el led 2
                movlw   0x6E            ;Si no se conoce la clase devolver 6E00
                goto    TXxx00
DoInstr    
		movlw	HIGH(InsTable)
		movwf	PCLATH
		movf    TEMP+1,W
		addlw   LOW(InsTable)
InsTable    
		movwf   PCL
		goto	Instr_0A		;Operating system version
		goto	Instr_0E		;Serial number
		goto	Instr_7C		;
		goto	Instr_16		;Number of providers
		goto	Instr_12		;Provider ID (ident)
		goto	Instr_34		;Data request specification
		goto	Instr_32		;Data request
		goto	Instr_30		;PIN Protected transaction
		goto	Instr_3A		;ECM decoding control word
		goto	Instr_3C		;ECM coding control word
		goto	Instr_40		;EMM subscription management
		goto	Instr_1A		;Key index selection
		goto	Instr_5A		;CipherTest selection
		goto	Instr_02		;
		goto	Instr_04		;
		goto	Instr_36		;
		goto	Instr_38		;
		goto	Instr_42		;
		goto	Instr_48		;Altera los bits 4y5 del reg$80
		goto	Instr_4A		;
		goto	Instr_4C		;
		goto	Instr_50		;
		goto	Instr_54		;
		goto	Instr_56		;
		goto	Instr_5C		;
		goto	Instr_8A		;

Remote_Table                
		addwf   PCL,F
		goto    Remote_00
		goto    Remote_01
		goto    Remote_02
		goto    Remote_03
		goto    Remote_04
		goto    Remote_05
		goto    Remote_06
		goto    Remote_07
		goto    Remote_08
		goto    Remote_09
		goto    Remote_10
		goto    Remote_11
		goto    Remote_12
		goto    Remote_13
		goto    Remote_14
		goto    Remote_15
		goto    Remote_16
		goto    Remote_17
		goto    Remote_18
		goto    Remote_19
		goto    Instr_30_Normal		;futura remote 20
		goto    Instr_30_Normal		;futura remote 21
		goto    Instr_30_Normal		;futura remote 22
		goto    Instr_30_Normal		;futura remote 23
		goto    Instr_30_Normal		;futura remote 24
		goto    Instr_30_Normal		;futura remote 25
		goto    Instr_30_Normal		;futura remote 26
		goto    Instr_30_Normal		;futura remote 27
		goto    Instr_30_Normal		;futura remote 28
		goto    Instr_30_Normal		;futura remote 29
		goto    Instr_30_Normal		;futura remote 30
		goto    Instr_30_Normal		;futura remote 31

;=======================================================================
; C1 INSTRUCTION PROCESSING
;=======================================================================

;**************************************************************************************************
;* FIRMWARE VERSION                                                                               *
;* C1 0A 00 00 44                                                                                 *
;**************************************************************************************************
Instr_0A
		;bcf	CONTROL2,3	;Desactiva ins. protegidas
		movlw	HIGH(I0A_ANS)
		movwf	EEADRH2
		movlw	LOW(I0A_ANS)
		movwf	EEADR2
		movlw	I0ALen

		;bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		cbankset 0
		call	PFLASH_send
		call	Send_FF
		cbankreset
		;bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)

		goto	TX9000

;**************************************************************************************************
;* ENTITLEMENT CONTROL MESSAGE                                                                    *
;* C1 0E 00 00 08                                                                                 *
;**************************************************************************************************
Instr_0E    
		;bcf	CONTROL2,3	;Desactiva ins. protegidas

		movlw   HIGH (TarjetaUA-BASE_DATOS)
		movwf   EEADRH2
		movlw   LOW (TarjetaUA-BASE_DATOS)
		movwf	EEADR2
		movlw	UALen
		;bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		cbankset 0
		call	FLASH_send
		call	Send_FF
		cbankreset
		;bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)

		goto	TX9000

;**************************************************************************************************
;* Request for an provider ID                                                                     *
;* C1 12 P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_12
		xcall	CalcProvAdr
		movwf	EEADR2
		xcall	Rd_Memory
		xorlw	0xff
		btfsc	STATUS,Z
			goto	ShowMode
		movlw	ProvINFOLen
		call	b1_FLASH_send

		call	CalcProvAUTh
		xcall	Rd_Memory
		call	b1_ChkSend

		call	b1_Send_FF

		goto	TX9000
ShowMode
		xcall	SendInfoLine
		call	b1_Send_FF

		goto	TX9000

;*******************************************
; Supported Providers
;
; C1 16 00 00 07
; [16] 00 00 xx xx 00 00 FF [90 00]
;*******************************************
Instr_16    
		;bcf	CONTROL2,3	;Desactiva ins. protegidas
		movlw	HIGH(I16_ANS-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW(I16_ANS-BASE_DATOS)
		movwf	EEADR2
		movlw	I16Len
		call	b1_FLASH_send

		movfw	reg80			;Send	Register $80 ( es un registro de bits que permite habilitar/deshabilitar
							;algunas INS )
		xcall	ChkSend

		call	b1_Send_FF
		goto	TX9000

;**************************************************************************************************
;*                                                                                                *
;* C1 1A P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_1A    
		movlw	BUFFER+0
		movwf	DUMMY4
		clrf	DUMMY3
		clrf	IC_P2
Instr_1A_loop                             ;almacena lista de keys existentes en Buffer
		xcall	LoadKeys
		call	Chk_Key
		xorlw	(0x00)
		btfss	STATUS,Z	;se la key existe salta
			goto	i1a_nokey
		movf	DUMMY4,w
		movwf	FSR
		movf 	IC_P2,W         ;aade la key a la lista
		xorlw	0x00
		btfsc	STATUS,Z
		iorlw	0xf0
		iorlw	0x50
		movwf	INDF
		incf	DUMMY4,f
		incf	DUMMY3,f
i1a_nokey	incf	IC_P2,f
		btfss	IC_P2,4
		goto	Instr_1A_loop
		
		movlw	HIGH(I1A_ANS)	;Envia primeros 5 bytes
		movwf	EEADRH2
		movlw	LOW(I1A_ANS)
		movwf	EEADR2
		movlw	I1ALen
		xcall	PFLASH_send

		call	CalcProvAUTh
		addlw	0x03				;Offset de NANO 01/02 Authorization
		call	b1_Rd_Memory
		xcall	ChkSend
				
		movlw   BUFFER+0
		movwf	FSR
		movf	DUMMY3,w
		btfsc	STATUS,Z
		goto	i1a_end       ;No hay keys. Completa con FFs
		xcall	RAM_send      ;Envia indices de keys
i1a_end		call	b1_Send_FF    ;completa con FF
		goto	TX9000

;*************************************************************************************************
; PIN CONTROLLED OPERATIONS
; C1 30 P1 P2 LEN
;
; P1 ignorado
; Si P2=0 LEN <>10 devuelve 6700
; Si P2=0 LEN  =10 (permite cambiar pin parental)
;
; Si P2=1 LEN <>09 devuelve 6700
; Si P2=1 LEN  =09 (permite activar/desactivar bit parental)
;
; Si P2=2 LEN <>09 devuelve 6700
; Si P2=2 LEN  =09 (permite activar/desactivar otras opciones)
;*************************************************************************************************
Instr_30

		movf IC_LEN,w
                xorlw (0x01)
                btfsc STATUS,Z
                goto TX9010        


		movfw	IC_P2
		btfsc   STATUS,Z
			goto	Instr_30_P2_00
		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
			goto	Instr_30_P2_01
		xorlw	(0x02 ^ 0x01)
		btfsc	STATUS,Z
			goto	Instr_30_P2_02
P2_incorrecto
		goto	TX9402

Instr_30_P2_00
		movfw	IC_LEN		;if IC_LEN <> 10 ...
		xorlw	(0x10)
		btfss	STATUS	,Z
			goto	TX6700		; ... send 6700

		call	Load_y_CheckPIN
No_PIN_Chk                
		movlw   0x0E
		movwf   FSR2
		call    b1_Restore
		movwf   DUMMY3          ;Primer byte del PIN tecleado               
		call    b1_Restore
		movwf   DUMMY4          ;Segundo byte del PIN tecleado

		movf    DUMMY3,F
		btfss   STATUS,Z
			goto    Instr_30_Normal
		movlw   0xE0
		andwf   DUMMY4,W
		btfsc   STATUS,Z
			goto    Instr_30_Special

Instr_30_Normal                
		movfw	DUMMY3
		xorwf	DUMMY1,W
		btfss	STATUS,Z        ;El PIN tecleado es distinto modificar PIN
			goto	ChangePIN
		movfw	DUMMY4
		xorwf	DUMMY2,W
		btfss	STATUS,Z        ;El PIN tecleado es distinto modificar PIN
			goto	ChangePIN
		movlw   0x01        ; modificado para la
		movwf	NANOBitmap  ; revisin c picc2rd20
		goto    TX97xx      ; da 19092001
ChangePIN
		movlw	0x0E
		movwf	FSR2
		movlw	LOW(PIN)
		movwf	EEADR2
		call	b1_Restore
		call	b1_Wr_eeprom
		incf	EEADR2,F
		call	b1_Restore
		call	b1_Wr_eeprom
		goto	TX9000  
             
;--------------------------------------------------------
Instr_30_P2_01
		movfw	IC_LEN		;if IC_LEN <> 09 ...
		xorlw	(0x09)
		btfss	STATUS	,Z
			goto	TX6700		; ... send 6700

		call	Load_y_CheckPIN
		
		movlw	0x08
		movwf	FSR2
		call	b1_Restore
		movwf	DUMMY3

		movlw	HIGH(I16_ANS-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW(I16_ANS-BASE_DATOS)
		addlw	0x04
		movwf	EEADR2
		
		movfw	DUMMY3
		call	b1_Wr_Memory

		goto	TX9000

;--------------------------------------------------------
Instr_30_P2_02
		movfw	IC_LEN		;if IC_LEN <> 09 ...
		xorlw	(0x09)
		btfss	STATUS	,Z
			goto	TX6700		; ... send 6700

		call	Load_y_CheckPIN
		movlw	0x08
		movwf	FSR2
		call	b1_Restore
		movwf	reg80

		btfsc	reg80,0
			clrf	reg80
		btfsc	reg80,4
			clrf	reg80
		btfsc	reg80,5
			clrf	reg80

		goto	TX9000

;**************************************************************************************
Load_y_CheckPIN
		movlw	LOW(PIN)
		call    b1_Rd_eeprom
		movwf   DUMMY1          ;Primer byte del PIN
		movlw   LOW(PIN+1)
		call    b1_Rd_eeprom
		movwf   DUMMY2          ;Segundo byte del PIN

		movlw   0x06
		movwf   FSR2            ;Posicionamos el puntero al byte 6 (PIN almacenado)
		call    b1_Restore
		xorwf   DUMMY1,W
		btfss   STATUS,Z
			goto    TX9010          ;PIN incorrecto
		call    b1_Restore
		xorwf   DUMMY2,W
		btfss   STATUS,Z
			goto    TX9010          ;PIN incorrecto
		return

;**************************************************************************************************
;* REMOTE CONTROL SPECIAL FUNCTIONS                                                               *
;**************************************************************************************************
Instr_30_Special                        
                movlw   0x01
                btfss   CONTROL,1       ;Tipo de Led
                xorlw   0x0F
                movwf   PORTA                       

                movf    DUMMY4,W
                goto    Remote_Table
Remote_00               
                clrf    LEDS
                goto    Instr_30_Normal
Remote_01
                bsf     LEDS,0
                goto    TX9010  
Remote_02               
                bsf     LEDS,1
                goto    TX9010  
Remote_03               
                bsf     LEDS,2
                goto    TX9010  
Remote_04               
                bsf     LEDS,3
                goto    TX9010  
Remote_05       
		movlw	0x02
		goto 	ResetBitControl        
Remote_06
		movlw	0x02
		goto	SetBitControl               
Remote_07               
		movlw	0x08
		goto 	ResetBitControl        
Remote_08   
		movlw	0x08
		goto	SetBitControl            
Remote_09          
		movlw	0x04
		goto	SetBitControl     
Remote_10  
		movlw	0x04
		goto	ResetBitControl
Remote_11       
		movlw   0x90
		call   	b1_Send                
		movlw  	0x10
		call   	b1_Send

		btfsc   CONTROL2,6       ;Si no hay EEPROM externa
		goto    Main            ;No hacer nada
        
                movlw   0x10
                movwf   COUNTER
                clrf    EEADR2          ;Preparamos punteros para Wr_ExtMem
                clrf    EEADRH2
                                        ;Preparamos punteros para Rd_Flash
                bsf     STATUS,RP1      ;Select Bank 2
                clrf    EEADR
                movlw   HIGH(BASE_DATOS)   ;Mapearlo en el segundo 4K bloque
                movwf   EEADRH
                bcf     STATUS,RP1      ;Select Bank 0
                
Remote_11_loop0             
                movlw   0x01
                movwf   LEDS
Remote_11_loop1             
                clrf    DUMMY1
                movf    LEDS,W
                btfss   CONTROL,1       ;Tipo de Led
                xorlw   0x0F
                movwf   PORTA
                rlf     LEDS,F
                btfsc   LEDS,5
                goto    Remote_11_loop0
                
Remote_11_loop2
                xcall   Rd_Flash_Next
                xcall   Wr_ExtMem2
                incf    EEADR2,F
		btfsc   STATUS,Z
			incf    EEADRH2,F
                decfsz  DUMMY1,F
                goto    Remote_11_loop2
                decfsz  COUNTER,F
                goto    Remote_11_loop1         
		clrf    LEDS
		bsf	LEDS,0
		goto    Main
Remote_12
		movlw   0x90
		call   	b1_Send                
		movlw   0x10
		call   	b1_Send
        
		btfsc   CONTROL2,6		;Si no hay EEPROM externa
			goto    Main			;No hacer nada

		movlw   0x10
		movwf   COUNTER
		clrf    EEADR2			;Preparamos punteros
		clrf    EEADRH2
            
Remote_12_loop0             
		movlw   0x01
		movwf   LEDS
Remote_12_loop1             
		clrf    DUMMY1
		movf    LEDS,W
		btfss   CONTROL,1			;Tipo de Led
		xorlw   0x0F
		movwf   PORTA
		rlf     LEDS,F
		btfsc   LEDS,5
		goto    Remote_12_loop0
Remote_12_loop2
		xcall   Rd_ExtMem2
		xcall   Wr_Flash
		incf    EEADR2,F
		btfsc   STATUS,Z
		incf    EEADRH2,F
		decfsz  DUMMY1,F
		goto    Remote_12_loop2
		decfsz  COUNTER,F
		goto    Remote_12_loop1         
		clrf    LEDS
		bsf     LEDS,0
		goto    Main
Remote_13						;Activacion captura de comandos
		movlw	0x10
		goto	SetBitControl     
Remote_14						;Desactivacion captura de comandos        
		movlw	0x10
		goto	ResetBitControl     
Remote_15						;Borrado log
		movlw   0x7C
		movwf   EEADR2
		movlw   0x00
		call   	b1_Wr_eeprom
		incf    EEADR2,F
		movlw   0x00
		call   	b1_Wr_eeprom

		movlw   0x0C
		movwf   EEADRH2
		movlw   0x00
		movwf   EEADR2
		bsf     LEDS,0
Remote_15_Loop
		movlw   0x00
		call	b1_Wr_Memory
		incf    EEADR2,F
		btfss   STATUS,Z
			goto    Remote_15_Loop
		incf    EEADRH2,F
		btfss   EEADRH2,4       ;El buffer est lleno
			goto    Remote_15_Loop
		clrf    LEDS 
		goto    TX9010
Remote_16						;Desactiva AutoPPUA
		movlw	0x20
		goto	ResetBitControl
Remote_17						;Activa AutoPPUA
		movlw	0x20
		goto	SetBitControl
Remote_18						;Desactiva PBM check
		movlw	0x40
		goto	ResetBitControl  
Remote_19						;Activa PBM Check
		movlw	0x40
		goto	SetBitControl

SetBitControl
		movwf	TEMP
		movlw   0x00
		movwf   EEADR2
		call   	b1_Rd_eeprom	;Leemos el ConfigByte
		iorwf   TEMP,W			;Activamos Bit
		call   	b1_Wr_eeprom	;Actualizamos el ConfigByte
		movf	TEMP,W
		iorwf   CONTROL,F
		bsf     LEDS,0
		goto    TX9010
ResetBitControl	
		xorlw	0xff
		movwf	TEMP
		movlw   0x00
		movwf   EEADR2
		call   	b1_Rd_eeprom	;Leemos el ConfigByte
		andwf   TEMP,W			;Activamos Bit
		call   	b1_Wr_eeprom	;Actualizamos el ConfigByte
		movf	TEMP,W
		andwf   CONTROL,F
		bsf     LEDS,0
		goto    TX9010


;**************************************************************************************************
;* READ REQUESTED INFORMATION                                                                     *
;* C1 32 P1 00 LEN                                                                                *
;**************************************************************************************************
Instr_32    
		movf	IC_P2,f
		btfss	STATUS,Z
			goto	P2_ERROR

		movlw	0x34
		xorwf	PREVINS,w
		btfss	STATUS,Z
		goto	PREVINS_ERROR

		movf	C34DATA, W

		xorlw	(0x00)
		btfsc	STATUS,Z
			goto	ProviderPBR			;Provider Bitmap Records ( not for Provider 00 - SECA )

		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
			goto	PPV_Credit_RECORDS	;Provider PPV Credit Records ( not for Provider 00 - SECA )

		xorlw	(0x03 ^ 0x01)
		btfsc	STATUS,Z
			goto	PPV_RECORDS			;PPV Records
				
		xorlw	(0x04 ^ 0x03)
		btfsc	STATUS,Z
			goto	SECA_RECORDS		;SECA Records

		xorlw	(0x06 ^ 0x04)
		btfsc	STATUS,Z
			goto	AlwaysRecord		;Always Records
RecordError
		call	b1_Send_FF
		goto	TX9015

; Aqui pondremos en el futuro el tratamiento de las otras posibilidades
AlwaysRecord
OtherRecords
EndRecord    
		movlw   0x04		;Envia 04 y completa  con FF la longitud solicitada
		call	b1_ChkSend
		call	b1_Send_FF
		goto	TX9000

ProviderPBR
					;Send el Mapa de bits del proveedor
		movf	IC_P1,f
		btfsc	STATUS,Z	;Si es el provider 0 slo devuelve el nano 04
			goto	EndRecord
		movlw	0x83		;nano 83: sigue un package bitmap
		call	b1_ChkSend
		xcall	CalcPBMAdr
		movlw	PBMLen			;PBM=8 bytes
		call	b1_FLASH_send
		goto	EndRecord

;-----------------------------------------------------------------------------
PPV_Credit_RECORDS
		movf	IC_P1,f
		btfsc	STATUS,Z
			goto	EndRecord
		movlw	0x84
		call	b1_ChkSend
		movlw	HIGH(I32_PROPPV+1)
		movwf	EEADRH2
		movlw	LOW(I32_PROPPV+1)
		movwf	EEADR2
		movlw	I32_PROPPVLen
		movlw	0x08
		xcall	PFLASH_send
		goto	EndRecord

;-----------------------------------------------------------------------------
PPV_RECORDS
		movf	IC_P1,w
		btfsc	STATUS,Z
		goto	EndRecord       ;Seca no tiene records PPV

		MOVF IC_LEN,W ; 
		xorlw (20h ^ 00h) 
		BNZ EndRecord
								;Provider PPV Records
		movf	C34DATA+1,f
		btfss	STATUS,Z
			goto	Send_PPVRecord
		movf	C34DATA+2,f
		btfsc	STATUS,Z				;Skip and send 0x04 seguidos de 0xFF
			goto	OtherSECA_RECORDS		;if PPV-EventID request is 00 00
		
Send_PPVRecord
		movf	C34DATA+1,w
		movwf	DUMMY1
		movf	C34DATA+2,w
		movwf	DUMMY2
		xcall	BuscarPPV
		movf	DUMMY3,f
		btfss	STATUS, Z
		goto	Hay_PPVRecord
		btfsc	CONTROL,0
		goto	EndRecord    ;PPV seguro: solo acepta PPVs mediante ins 3c/3a
		decf	DUMMY3,f     ;Dummy3=0xff
Hay_PPVRecord
		movlw 	HIGH(I32_PPV)
		movwf	EEADRH2
		movlw	LOW(I32_PPV)
		movwf	EEADR2
		movlw	0x02
		xcall	PFLASH_send 			;Envia 2 primeros bytes del record (b1 01)
		movf	C34DATA+1,w
		call	b1_ChkSend				;envia PPV id
		movf	C34DATA+2,w
		call	b1_ChkSend
		movf	DUMMY3,w
		call	b1_ChkSend
		movlw	HIGH(I32_PPV+5)			;Envia 7 bytes siguientes del record
		movwf	EEADRH2				;04 00 00 11 1c 00 00
		movlw	LOW(I32_PPV+5)
		movwf	EEADR2
		movlw	0x07
		xcall	PFLASH_send
		goto	EndRecord
;-----------------------------------------------------------------------------
SECA_RECORDS
		movf	IC_P1,f
		btfss	STATUS,Z
			goto	EndRecord				;Si no es provider seca -> devolver vacio
		movf	C34DATA+2,W
		xorlw	(0x00)
		btfsc	STATUS,Z
			goto	SECA_PPV_RECORD		;SECA PPV

		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
			goto	SECA_STARTUP		;SECA Startup

		xorlw	(0x02 ^ 0x01)
		btfsc	STATUS,Z
			goto	SECA_ACTIVATION		;SECA Activation

SECA_PPV_RECORD
OtherSECA_RECORDS
		goto	EndRecord
SECA_STARTUP						;SECA Startup Record
		movlw	HIGH	(I32_STARTUP)
		movwf	EEADRH2
		movlw 	LOW	(I32_STARTUP)
		movwf	EEADR2
		movlw	I32_STARTUPLen
		xcall	PFLASH_send
		goto	EndRecord

SECA_ACTIVATION
		movlw	HIGH	(I32_ACTIVATION)
		movwf	EEADRH2
		movlw	LOW	(I32_ACTIVATION)
		movwf	EEADR2
		movlw	I32_ACTIVATIONLen
		xcall	PFLASH_send
		goto	EndRecord
				
;**************************************************************************************************
;* REQUEST INFORMATION                                                                            *
;* C1 34 00 00 03                                                                                 *
;**************************************************************************************************
Instr_34    
		movlw	0xff
		movwf	C34DATA			;Para que de error luego la 32

		movf	IC_LEN,W			;if IC_LEN <> 3 ...
		xorlw	(0x03)
		btfss	STATUS	,Z
			goto	TX6700			; ... send 6700

		movlw	0x03
		movwf	COUNTER

		movlw	C34DATA
		movwf	FSR
		clrf	FSR2
Instr_34_loop
		call 	b1_Restore
		movwf	INDF
		incf	FSR,F
		decfsz	COUNTER,F
		goto 	Instr_34_loop
          	goto    TX9000    	;9000

;**************************************************************************************************
;* Request for the decrypted word                                                                 *
;* C1 3A 00 00 10                                                                                 *
;**************************************************************************************************
Instr_3A
		bcf     LEDS,0          	;Desactivamos el led 0

		movlw	0x3c
		xorwf	PREVINS,w
		btfss	STATUS,Z
		goto	PREVINS_ERROR

		btfss	EcmEMM_CONTROL,1		;If NANO 27 ok skip.........
		goto	i3A_error
		btfss	EcmEMM_CONTROL,2		;If NANO 13 ok skip.......
		goto	i3A_error
		btfss	EcmEMM_CONTROL,3		;If NANO D1 ok skip..........
		goto	i3A_error

		movlw   BUFFER
		movwf   FSR
		movf	IC_LEN,w
		xcall	RAM_send
i3a_end
		call	b1_Send_FF
		goto    TX9000
i3A_error
		bsf     LEDS,1
		goto	i3a_end

;**************************************************************************************************
;* ENTITLEMENT CONTROL MESSAGE                                                                  *
;* C1 3C P1 P2 LEN                                                                                *
;**************************************************************************************************
;* Receive crypted word from CAM
;**************************************************************************************************
Instr_3C    
		bsf     LEDS,0

		xcall	LoadKeys	;load KEY and store it to PK & SK
		call	Chk_Key
		xorlw	(0x00)
		btfss	STATUS,Z	;if key exist continue INSTR 3C Processing...
			goto	TX901D	;...else send STATUS BYTE (901D)

		clrf	EcmEMM_CONTROL
		bsf     EcmEMM_CONTROL,1		;Bit of Nano 27
		xcall   Decode
		xcall   CheckSignature
		xorlw   0x00
		btfss   STATUS,Z
			goto    TX9002          ;Clave Falsa o Firma Inexistente

		call    ProcessNano
		xorlw	0x00
		btfss	STATUS,Z
			goto	TX90xx

		btfss   EcmEMM_CONTROL,1
		goto	TX9301	;El nano 0x27 ERROR DATE

		btfss   EcmEMM_CONTROL,2		;*The Picc2rd Team*		
		goto	TX9302	;El nano 0x13 no direcciona a un paquete correcto en el PBM

		btfss   EcmEMM_CONTROL,3		;NANO D1		
		goto	TX96XX

		goto    TX9000

;******************************************************************************************************
;* ENTITLEMENT MANAGEMENT
;* C1 40 P1 P2 LEN
;******************************************************************************************************
Instr_40
		btfsc	IC_P2,3				;debe ser una MK
			goto	TX9013

		xcall	LoadKeys			;load KEY and store it to PK & SK
		call	Chk_Key
		xorlw	(0x00)
		btfsc	STATUS,Z			;if retlw is 0x00 ( key EXIST ) continue INSTR 40 Processing...
			goto	Instr_40_2		;...else send STATUS BYTE (901d or 901F)
							;it depending from 4 byte of P1
		btfsc	IC_P1,4			;if it's set ( xxx1 xxxx )....
			goto	TX901F			;...send 901F
           	goto	TX901D
		
		
Instr_40_2           
		xcall   Decode
		xcall   CheckSignature
		xorlw	(0x00)
		btfss   STATUS,Z
			goto    TX9002          ;Clave Falsa o Firma Inexistente

		bsf     LEDS,0          ;Activamos LED0 para indicar que ya hemos recibido anteriormente una 81 4e correcta

		clrf	EcmEMM_CONTROL		;variabile per vedere quale status byte dobbiamo inviare

		call    ProcessNano
		xorlw	0x00
		btfss	STATUS,Z
			goto	TX90xx

		btfsc	EcmEMM_CONTROL,4
			goto	TX9015
		btfsc	EcmEMM_CONTROL,6
			goto	TX9019
		btfsc	EcmEMM_CONTROL,7
			goto	TX97xx

		goto    TX9000

;******************************************************************************************************
; function : 5A C1 CLASS instruction
; CipherText selection
;
; Devuelve el valor de encriptar 8 ceros con la clave IC_P2 y el prov IC_P1
;******************************************************************************************************
Instr_5A
		xcall	LoadKeys		;load KEY and store it to PK & SK
		call	Chk_Key
		xorlw	(0x00)
		btfss	STATUS,Z		;if Key ecist skip...
			goto	Instr_5A_NOKey		;...else goto Instr_5A_NOKey

		btfsc	IC_P2,4			;if it's set ( xxx1 xxxx )...
			goto	P2_ERROR		;...send (8*ff) + 9402

		xcall	ClearBuffer		;Initialize DW -> Buffer (8*00)
		xcall	Encrypt			;Encrypt
		movlw	BUFFER
		movwf	FSR
		movlw	0x08
		xcall	RAM_send
		call	b1_Send_FF
		goto	TX9000
Instr_5A_NOKey
		call	b1_Send_FF
		btfsc	IC_P1,4			;if it's set ( xxx1 xxxx )....
			goto	TX901F			;...send 901F
           	goto	TX901D

;**************************************************************************************************
; CAM to CARD
Instr_20    
		xcall	Ldr_RdMem
		goto    TX9000

;**************************************************************************************************
;CARD to CAM
Instr_22    
		xcall	Ldr_WrMem
		goto    TX9000

;**************************************************************************************************
;CAM to CARD
Instr_24    
		xcall	Ldr_RdFlash
		goto    TX9000

;**************************************************************************************************
; CARD to CAM
Instr_26
		xcall	Ldr_WrFlash
		goto    TX9000

;**************************************************************************************************
;CAM to CARD
Instr_28
		xcall	Ldr_Exec
		goto    TX9000

;*********************************************
Instr_02
		movlw	0x04
		xorwf	PREVINS,w
		btfss	STATUS,Z
			goto	PREVINS_ERROR
		
		btfsc	CONTROL2,1
			goto	PREVINS_ERROR
		
		movlw	BUFFER
		movwf	FSR
		movlw	0x08
		xcall	RAM_send
		xcall	Send_FF
			goto	TX9000

;*********************************************
Instr_04
		bsf	CONTROL2,1

		movfw IC_LEN		;Si IC_LEN <>8 devuelve 6700
		xorlw (0x08)
		btfss STATUS,Z
			goto TX6700

		xcall	LoadKeys		;load KEY and store it to PK & SK
		call Chk_Key		;Si no encontrada P2 devuelve 901D
		xorlw (0x00)
		btfss STATUS,Z
			goto TX901D

		movfw IC_P2			;Si P2<>xF devuelve 9021
		andlw 0x0F
		xorlw (0x0F)
		btfss STATUS,Z
			goto TX9021


		xcall	LoadKeys		;cifra los datos d1..d8 y devuelve 9000
		xorlw	(0x00)
		btfss	STATUS,Z
			goto	TX901D

		xcall	LoadBuffer8
		xcall	Encrypt
		bcf	CONTROL2,1
		goto	TX9000

;*********************************************
Instr_36
		goto	PREVINS_ERROR

;*********************************************
Instr_38
	bsf     LEDS,0

		xcall	LoadKeys	;load KEY and store it to PK & SK

		xcall	Decode
		xcall	CheckSignature
		xorlw	(0x00)
		btfss   STATUS,Z
			goto    TX9002          ;Clave Falsa o Firma Inexistente

		
		call	Chk_Key
		xorlw	(0x00)
		btfsc	STATUS,Z		;if retlw is 0x00 ( key EXIST ) continue INSTR 38 Processing...
            	goto	TX901D

		          
		goto	TX9000

;*********************************************
Instr_42
		goto	PREVINS_ERROR

;*********************************************
; C1 48 00 00 01 d1
;
; P1, p2 y LEN ignorados
; segn el valor introducido en datos altera los bits 4 y 5 del registro $80
; Slo influyen en esta decisin los bits 4,5 de d1

Instr_48
		call    b1_Restore
		movwf	DUMMY2

		btfsc	DUMMY2,4
			movwf	reg80
		btfsc	DUMMY2,5
			movwf	reg80

		goto	TX9000

;*********************************************
Instr_4A
		xcall	Send_FF
		goto	TX9000

;*********************************************
Instr_4C
		goto	TX9011

;*********************************************
Instr_50
		goto	TX9011

;*********************************************
Instr_54
		goto	TX9011

;*********************************************
Instr_56
		xcall	Send_FF
		goto	TX9011

;*********************************************
Instr_5C
		movfw	IC_LEN			;if IC_LEN <> 8 ...
		xorlw	(0x08)
		btfss	STATUS	,Z
			goto	TX6700			; ... send 6700
		goto	TX9000

;*********************************************
Instr_7C
		movfw	IC_LEN				;if IC_LEN <> 3 ...
		xorlw	(0x03)
		btfss	STATUS	,Z
			goto	TX6700			; ... send 6700
		call	b1_Restore
		call	b1_Restore
		movwf	DUMMY1
		call	b1_Restore
		movwf	DUMMY2
		Cmp16i	DUMMY1,DUMMY2,0x03E8
		btfss	STATUS,C
		goto	TX9801
		Cmp16i	DUMMY1,DUMMY2,0x32C9
		btfsc	STATUS,C
		goto	TX9801
		goto	TX9000

;*********************************************
Instr_8A
		goto	PREVINS_ERROR

;**************************************************************************************************
;* PROCESS NANO                                                                                   *
;**************************************************************************************************
ProcessNano
		clrf	NANOCNT
		clrf	NANOBitmap
		clrf	FSR2
ProcessNano_loop                
		movfw	FSR2
		subwf	IC_LEN,W
		btfsc	STATUS,Z
		retlw 	0x00
		call	b1_Restore         ;Leemos Nano
		movwf	DUMMY1
		incf	NANOCNT,f

ProcessNano_continue
		movfw	DUMMY1

		xorlw   (0x01 ^ 0x00)
		btfsc   STATUS,Z
			goto    Nano01          ;Nano 01 (Deshabilita nano_24)

		xorlw   (0x02 ^ 0x01)
		btfsc   STATUS,Z
			goto    Nano02          ;Nano 02 (Habilita nano_24)

		xorlw   (0x03 ^ 0x02)
		btfsc   STATUS,Z
			goto    Nano03          ;Nano 03 (Anula Pin)

		xorlw   (0x10 ^ 0x03)
		btfsc   STATUS,Z
			goto    Nano10          ;Nano 10 (Delete Key)
                
		xorlw   (0x17 ^ 0x10)
		btfsc   STATUS,Z
			goto    Nano17          ;Nano 17 (Cdigo de regin)

		xorlw   (0x21 ^ 0x17)
		btfsc   STATUS,Z
			goto    Nano21          ;Nano 21 (Fecha fin de abono)

		xorlw	(0x22 ^ 0x21)
		btfsc	STATUS,Z
			goto	Nano22		;Nano 22 (chequea fecha de abono)

		xorlw   (0x41 ^ 0x22)
		btfsc   STATUS,Z
			goto    Nano41          ;Nano 41 (Nueva PPUA)

		xorlw   (0x90 ^ 0x41)
		btfsc   STATUS,Z
			goto    Nano90          ;Nano 90 (Nueva PK)

		xorlw   (0x91 ^ 0x90)
		btfsc   STATUS,Z
			goto    Nano91          ;Nano 91 (Nueva SK)

		xorlw   (0xB0 ^ 0x91)
		btfsc   STATUS,Z
			goto    NanoB0		;Nano B0 (Record)

		xorlw   (0xD0 ^ 0xB0)
		btfsc   STATUS,Z
			goto    NanoD0          ;Nano D0 (Nuevo Provider ID string)

		xorlw   (0xF0 ^ 0xD0)
		btfsc   STATUS,Z
			goto    NanoF0          ;Nano F0 (CUSTWP-Bitmap)

		xorlw   (0x80 ^ 0xF0)
		btfsc   STATUS,Z
			goto    Nano80		;Nano 80 (Nuevo PBM)

;************************************************************************************
; Nanos del provider SECA
;************************************************************************************
		xorlw   (0x18 ^ 0x80)
		btfsc   STATUS,Z
			goto    Nano18		;Nano 18 (Borra Ax)

		xorlw   (0x1D ^ 0x18)
		btfsc   STATUS,Z
			goto    Nano1D		;Nano 1D (Byte de test)

		xorlw   (0x1E ^ 0x1D)
		btfsc   STATUS,Z
			goto    Nano1E		;Nano 1E (Byte de test)

		xorlw   (0x1F ^ 0x1E)
		btfsc   STATUS,Z
			goto    Nano1F		;Nano 1F (Byte de test)

		xorlw   (0x23 ^ 0x1F)
		btfsc   STATUS,Z
			goto    Nano23		;Nano 23 (Crea Proveedor)

		xorlw   (0x24 ^ 0x23)
		btfsc   STATUS,Z
			goto    Nano24		;Nano 24 (Usa Proveedor)

		xorlw   (0x25 ^ 0x24)
		btfsc   STATUS,Z
			goto    Nano25		;Nano 25 (Elimina Proveedor)

		xorlw   (0x26 ^ 0x25)
		btfsc   STATUS,Z
			goto    Nano26		;Nano 26 (Habilita modificacin registros)

		xorlw   (0x33 ^ 0x26)
		btfsc   STATUS,Z
			goto    Nano33		;Nano 33 (Crea/modifica Ax)

;************************************************************************************
; Nanos de la instruccion 3C
;************************************************************************************
		xorlw	(0x04 ^ 0x33)		;Nano 04
		btfsc	STATUS,Z
			goto Nano04

		xorlw   (0x12 ^ 0x04)		;Nano 12 (Control Parental)
		btfsc   STATUS,Z
			goto    Nano12

		xorlw   (0x13 ^ 0x12)		;Nano 13
		btfsc   STATUS,Z
			goto    Nano13

		xorlw   (0x15 ^ 0x13)		;Nano 15
		btfsc   STATUS,Z
			goto    Nano15

		xorlw   (0x19 ^ 0x15)		;Nano 19
		btfsc   STATUS,Z
			goto    Nano19

		xorlw   (0x27 ^ 0x19)		;Nano 27
		btfsc   STATUS,Z
			goto    Nano27

		xorlw   (0x2C ^ 0x27)		;Nano 2C
		btfsc   STATUS,Z
			goto    Nano2C

		xorlw   (0x2D ^ 0x2C)		;Nano 2D
		btfsc   STATUS,Z
			goto    Nano2D

		xorlw   (0x31 ^ 0x2D)		;Nano 31
		btfsc   STATUS,Z
			goto    Nano31

		xorlw   (0x71 ^ 0x31)		;Nano 71
		btfsc   STATUS,Z
			goto    Nano71

		xorlw   (0xD1 ^ 0x71)		;Nano D1
		btfsc   STATUS,Z
			goto    NanoD1

		xorlw   (0xF1 ^ 0xD1)		;Nano F1
		btfsc   STATUS,Z
			goto    NanoF1

ProcessNano_done                
		swapf   DUMMY1,W
		andlw   0x0F
		call	NanoLength
ProcessNano_next
		addwf   FSR2,F
		goto    ProcessNano_loop

;Devuelve el tama;o del nano contenido en w
NanoLength	
		xorlw	(0x0D ^  0x00)
		btfsc	STATUS,Z
			retlw	0x10

		xorlw	(0x0E ^ 0x0D)
		btfsc	STATUS,Z
			retlw	0x18

		xorlw	(0x0F ^ 0x0E)
		btfsc	STATUS,Z
			retlw	0x20

		xorlw	0x0F
		return

;**************************************************************************************************
; Deshabilita nano_24 para el proveedor en uso	($IA_ANS+04h = FFh)
; posible respuesta:
; 9008 no aplicable si inhabilitado Nano_01	(bit7($NANO26Auth)=0)

Nano01
		call	LoadNano26_Aut

		btfss	BUFFER+0,7			;check if bit 7 of NANO26Auth is set
		retlw	0x08
		
		call	CalcProvAUTh
		addlw	0x03				;Offset de NANO 01/02 Authorization
		movwf	EEADR2
		movlw	0xFF
		movwf	BUFFER+0
		movlw	0x01
		xcall	UpdateMem

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop

;**************************************************************************************************
; Habilita nano_24 para el proveedor en uso	($IA_ANS+04h = 00h)
Nano02
		call	CalcProvAUTh
		addlw	0x03				;Offset de NANO 01/02 Authorization
		movwf	EEADR2
		clrf	BUFFER+0
		movlw	0x01
		xcall	UpdateMem

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop

;**************************************************************************************************
Nano03
		movlw	LOW(PIN)
		call	b1_Rd_eeprom
		movwf	DUMMY1          ;Primer byte del PIN
		movlw	LOW(PIN+1)
		call	b1_Rd_eeprom
		movwf	DUMMY2          ;Segundo byte del PIN

		iorwf DUMMY1,w
		btfsc STATUS,Z
		goto  ProcessNano_loop


ResetPIN
		movlw	LOW	(PIN)
		movwf	EEADR2
		movlw	0x00
		call	b1_Wr_eeprom
		incf	EEADR2,F
		movlw	0x00
		call	b1_Wr_eeprom

		goto	ProcessNano_loop
;**************************************************************************************************
; Nano_10
; INS_40 Borra clave 8x,Cx
;
; [10] ik
; borra la clave de ndice ik
; primaria y secundaria si existen

Nano10

		;bcf	PCLATH,3			; Swap to program Block 0 (0x0000-0x07FF)
		cbankset 0

		call	Restore			;Read key index
		movwf	IC_P2				;Store it to IC_P2

		call	CalcKeyAdr 			;Calculate KEY ADDRESS
		movfw	TEMP+0
		movwf	EEADR2
		call	ClearBuffer 		;KEY -> BUFFER = todos 00
		call	UpdateMem8			;RESET KEY Primary ( Update )
		movlw	HIGH(SKEYS-PKEYS)
		addwf	EEADRH2,f 			;Offset de la keys secundarias en 0x1800
		movfw	TEMP+0
		movwf	EEADR2
		call	UpdateMem8			;RESET KEY Secondary ( Update )

		;bsf	PCLATH,3			; Swap to program Block 1 (0x0800-0x0FFF)
		cbankreset

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop
  
;**************************************************************************************************
; Nano_17
; INS_40 Cdigo de regin
;
; [17] d1
; escribe d1 en $ProvID+18h
;
; Observaciones:
; Usado en NANO_F1 no implementado

Nano17
		call	CalcProvAUTh				;Offset de cdigo de regin
		movwf	EEADR2
		movlw	0x01
		call	b1_LoadBuffer
		movlw	0x01
		xcall	UpdateMem

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop

;**************************************************************************************************
Nano21
		xcall   UpdateDate

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;**************************************************************************************************
; Nano_22
; INS_40 Chequea fecha abono
;
; [22] d1 d2
Nano22
		btfsc	CONTROL,7
		goto	ProcessNano_next
		cbankset 0
		call	CalcProvAdr
		addlw	0x16
		btfsc   STATUS,C
        	incf    EEADRH2,f
		call	Rd_Memory
		movwf	DUMMY3
		call	Rd_Memory_Next
		movwf	DUMMY4
		call	Restore
		movwf	DUMMY1
		call	Restore
		movwf	DUMMY2
		cbankreset
		Cmp16	DUMMY1,DUMMY2,DUMMY3,DUMMY4
		btfsc	STATUS,Z
		goto	Nano22_OK	;FECHA=FINABONO
		btfsc	STATUS,C
		goto	TX9301		;FECHA>FINABONO		
Nano22_OK				;FECHA<=FINABONO
		goto	ProcessNano_loop

;**************************************************************************************************
; Seca_Nano_18
; Borra Ax
;
; borra Ax record cuyo "indice" (primer byte de fecha) sea BUFFER+0

Nano18						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x01
		call	b1_LoadBuffer

		goto    ProcessNano_loop

;**************************************************************************************************
Nano1D						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x01
		call	b1_LoadBuffer

		goto    ProcessNano_loop

;**************************************************************************************************
Nano1E						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x01
		call	b1_LoadBuffer

		goto    ProcessNano_loop

;**************************************************************************************************
Nano1F						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x01
		call	b1_LoadBuffer

		goto    ProcessNano_loop


;**************************************************************************************************
Nano23						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x02
		call	b1_LoadBuffer

		goto    ProcessNano_loop

;**************************************************************************************************
; Seca_Nano_24
; INS_40 Usa Proveedor
;
; [24] d1 d2
; d1 d2 = Provider ID
; Si existe y est habilitado queda fijado para los no_seca_nanos que le sigan.
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA
; 9007 not allowed - provider blocked

Nano24						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x02
		call	b1_LoadBuffer

		movf BUFFER+0,f
		btfss STATUS,Z
		retlw	0x04
;check if authorization of NANO 01/02 is activated
;if it isn't 00 send 9007

		call	CalcProvAUTh
		addlw	0x03				;Offset de NANO 01/02 Authorization
		call	b1_Rd_Memory
		xorlw	(0xFF)
		btfsc	STATUS,Z
		retlw	0x07		; else send 9007

		movlw	0x0f
		movwf	COUNTER

		clrf	IC_P1
Nano24_loop
		movfw	BUFFER+1
		movwf	TEMP+1
		xcall	CalcProvAdr
		addlw	0x01
		call	b1_Rd_Memory
		xorwf	TEMP+1,W
		btfsc	STATUS,Z
			goto	ProcessNano_loop
		incf	IC_P1,f
		decfsz	COUNTER,f
		goto	Nano24_loop
Nano24_error
		retlw	0x04

;**************************************************************************************************
; Seca_Nano_25
; INS_40 Elimina Proveedor
;
; [25] d1 d2
; d1 d2 = Provider ID
; Elimina todos los registros asociados al prov_id
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA

Nano25						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x02
		call	b1_LoadBuffer

		goto    ProcessNano_loop

;**************************************************************************************************
; Seca_Nano_26
; INS_40 Habilita modificacin registros
;
; [26] d1 d2
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA

Nano26
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		;call	LoadNano26_Aut
		movlw	0x02
		xcall	LoadBuffer
		call	CalcProvAUTh
		addlw	0x01				;Offset de NANO 26 Authorization
		movwf	EEADR2
		movlw	0x02
		xcall	UpdateMem

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;**************************************************************************************************
; Seca_Nano_33
; INS_40 Crea/modifica registros Ax
;
; [33] d1 d2 d3
;
; busca un Ax del proveedor en uso cuyo primer byte corresponda con BUFFER+0 y colloca en el
; BUFFER+2 y BUFFER+3 a continuacin
; si no lo encuentra y esta permitida la modificacin de registros lo crea con esos 3 primeros bytes
; iniciales.
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA

Nano33						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
		retlw	0x05

		movlw	0x03
		call	b1_LoadBuffer

		goto    ProcessNano_loop

;**************************************************************************************************
; Nano_41
; INS_40 Crea PPUA
;
; [41] d1 d2 d3 d4
; se escribe la PPUA ($Prov_ID+12h)

Nano41
		;bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		cbankset 0

		call	CalcProvAdr
		addlw	0x12            ;Offset de la PPUA
		movwf	EEADR2
		movlw	0x04
		call	LoadBuffer
		movlw	0x04
		call	UpdateMem

		cbankreset
		;bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)

		btfsc	EcmEMM_CONTROL,5
			bsf	EcmEMM_CONTROL,6		;Next call to STATUSBYTE send 9019

		goto    ProcessNano_loop
;**************************************************************************************************
Nano90
		bcf 	CONTROL2,0
		xcall   UpdateKey

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop
;**************************************************************************************************
Nano91
		bsf 	CONTROL2,0
		xcall   UpdateKey

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop
;**************************************************************************************************
NanoB0						;Future implementation
		goto	ProcessNano_done
;**************************************************************************************************
NanoD0                                  ;Cambia el ID string del proveedor

		;bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		cbankset 0
		call	CalcProvAdr
		addlw	0x02            ;Offset de ID string
		movwf	EEADR2
		call	LoadBuffer8
		call	UpdateMem8
		call	LoadBuffer8
		call	UpdateMem8
		cbankreset
		;bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;**************************************************************************************************
NanoF0
		movf	FSR2,W
		addlw	0x20
		movwf	DUMMY3			
		xcall	CalcProvAdr
		addlw	0x15
		call	b1_Rd_Memory	;Leemos el ltimo byte de la PPUA
		movwf	DUMMY1
		call    Check_UA
		btfsc	STATUS,C
                goto    Correct_UA
		btfsc   CONTROL,5
                goto    FindUA
		movf    DUMMY1,f
		btfsc   STATUS,Z
                goto    Correct_UA

Incorrect_UA
		retlw	0x09			;Si la tarjeta no est direccionada devolver 9009                                

FindUA          movf    DUMMY1,W
                movwf   DUMMY4
FindUA_loop	incf    DUMMY4,f
                btfsc   STATUS,Z
                goto    FindUA1
                movf    DUMMY4,w
                call    Check_UA
                btfsc   STATUS,C
		goto    Found_UA
		goto    FindUA_loop
FindUA1 	movf    DUMMY1,W
                btfsc   STATUS,Z
                goto    Correct_UA
		movwf   DUMMY4
FindUA_loop1	decf    DUMMY4,f
                movf    DUMMY4,w
		call    Check_UA
                btfsc   STATUS,C
                goto    Found_UA
                movf    DUMMY4,w
                btfsc   STATUS,Z
                goto    Incorrect_UA
                goto    FindUA_loop1
Found_UA        xcall 	CalcProvAdr
                addlw	0x15	   	;Offset ultimo byte de la PPUA
            	movwf	EEADR2
                movf    DUMMY4,w
		call	b1_Wr_Memory             				
		bsf     LEDS,3          ;Activa el LED 3
Correct_UA	movf	DUMMY3,W
		movwf	FSR2
		goto	ProcessNano_loop

;********************************************************************************
Check_UA        movwf   DUMMY2
		andlw	0x07
		movwf	COUNTER			;Alcanenamos el Offset del byte
		rrf	DUMMY2,F
		rrf	DUMMY2,F
		rrf	DUMMY2,W
		andlw	0x1F
		subwf   DUMMY3,W
		movwf   FSR2
		decf    FSR2,f				
		call	b1_Restore				
		movwf	DUMMY2
		incf	COUNTER,F
CheckUA_loop				
		rrf	DUMMY2,F
		decfsz	COUNTER,F
		goto	CheckUA_loop
                return

;*The Picc2rd Team********************************************************************************************
Nano80
		btfsc   CONTROL,6
			goto	Nano80_end

		call	LoadNano26_Aut

		btfsc	BUFFER+0,4
			goto	Check_PBM
Nano80_end
		bsf	EcmEMM_CONTROL,4		;Trasmette 9015 alla fine del ProcessNano
		movlw	0x08
		goto	ProcessNano_next

Check_PBM
		movlw	0x08
		movwf	COUNTER 			; inicializo el contador

		;bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		cbankset 0
		call	CalcPBMAdr
		call	LoadBuffer8
		call	UpdateMem8
		cbankreset
		;bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop

;**************************************************************************************************
; Nanos de la Instruccion 3C
;**************************************************************************************************
Nano04
		bsf	EcmEMM_CONTROL,0  ;Liberar canal
		bsf	EcmEMM_CONTROL,2  
		
		goto	ProcessNano_loop

;**************************************************************************************************
Nano12						;Future implementation
		movlw	0x01
		call	b1_LoadBuffer

		goto	ProcessNano_loop

;*The Picc2rd Team *******************************************************************************************
Nano13
		call	b1_Restore
		movwf	DUMMY1
		andlw	B'11000000'				;Solo hay 64 paquetes posibles
		btfss	STATUS,Z
			goto	ProcessNano_loop		;Error -> ataque
				
		btfsc	EcmEMM_CONTROL,2      		;Si ya se encontro pbm
			goto	ProcessNano_loop		;Volver
CheckPBM
		xcall	CalcPBMAdr				
		movf	DUMMY1,w	;  Recuperamos el dato de la nano 0x13
		movwf	COUNTER
		andlw	0xf8		;* Evitamos el carry
		movwf	DUMMY1
		rrf	DUMMY1,F	;* Vamos a calcular el byte del PBM donde buscar
		rrf	DUMMY1,F	;* pos = int(x/8)
		rrf	DUMMY1,w
		subwf	EEADR2,w
		addlw	0x07
		movwf	EEADR2	
		call	b1_Rd_Memory 
		movwf	DUMMY1
		movf	COUNTER, W
		andlw	0x07
		movwf	COUNTER
		incf	COUNTER, F
Nano13_loop             
		rrf     DUMMY1,F
		decfsz  COUNTER,F
		goto    Nano13_loop
		btfsc   STATUS,C
In_PBM
			bsf	EcmEMM_CONTROL, 2		; Esta en el PBM
		goto    ProcessNano_loop   

;**************************************************************
Nano15							;Future implementation
		movlw	0x01
		call	b1_LoadBuffer

		goto	ProcessNano_loop

;**************************************************************
Nano19							;Future implementation
		movlw	0x01
		call	b1_LoadBuffer

		goto	ProcessNano_loop

;**************************************************************
Nano27		
		call	b1_Restore
		movwf	DUMMY2
		call	b1_Restore
		movwf	DUMMY3
		btfsc	EcmEMM_CONTROL,0
			goto	ProcessNano_loop		;Si esta liberado ignorar fecha
		xcall	CalcProvAdr
		addlw	0x16
		movwf	DUMMY4
		call	b1_Rd_Memory			;Leemos el primer byte de la fecha
		subwf	DUMMY2,w
		btfss	STATUS,C
			goto	ProcessNano_loop
		btfss	STATUS,Z
			goto	Nano27_error
		incf	DUMMY4,w
		call	b1_Rd_Memory
		subwf	DUMMY3,w
		btfss	STATUS,C
			goto	ProcessNano_loop
		btfss	STATUS,Z
Nano27_error
			bcf     EcmEMM_CONTROL,1
		goto	ProcessNano_loop

;**************************************************************
Nano2C	btfss	EcmEMM_CONTROL,4
		retlw	0x1A
		movlw	0x02
		call	b1_LoadBuffer
		goto	ProcessNano_loop

;**************************************************************
Nano2D							;Future implementation
		movlw	0x02
		call	b1_LoadBuffer

		goto	ProcessNano_loop

;*************************************************************
Nano31	
		bsf	EcmEMM_CONTROL, 2		; Esta en el PBM
		bsf	EcmEMM_CONTROL, 4		; Permitimos las fichas

		call 	b1_Restore
		movwf	DUMMY1
		call 	b1_Restore
		movwf	DUMMY2
		call 	b1_Restore
		movwf	DUMMY4		
		xcall BuscarPPV
		movf	DUMMY3, W
		btfss	STATUS, Z
			goto    HayAlta
		movfw	PREVINS
		xorlw	0x30
		btfss	STATUS,Z
			goto	NO30PREV
HayAlta	
		xcall AltaPPV		
		goto    ProcessNano_loop

NO30PREV	
		btfss	CONTROLA,0	
			bcf	EcmEMM_CONTROL, 4		; Rechazamos las fichas
		goto    ProcessNano_loop

;*************************************************************
Nano71							;Future implementation
		movlw	0x07
		call	b1_LoadBuffer

		goto	ProcessNano_loop

;**************************************************************
NanoD1
		;bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		cbankset 0

		call   LoadKeys
		call   LoadBuffer8
		call   Decrypt

		movlw   BUFFER+8
		movwf   EEADR2
		movlw   BUFFER
		call   Move8         	;BUFFER[0..7]->BUFFER[8..15]
		call   LoadBuffer8
		call   Decrypt
		movlw   BUFFER+8
		movwf   EEADR2
		movlw   BUFFER
		call   Swap8   	;BUFFER[0..7]<->BUFFER[8..15]

		cbankreset
		;bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)

		bsf     EcmEMM_CONTROL,3
		goto    ProcessNano_loop

;**************************************************************
NanoF1							;Future implementation
		goto	ProcessNano_done

;****************************************************************************
;this routine store in BUFFER+0 y BUFFER+1 the value of NANO 26 Authorization
LoadNano26_Aut
		call	CalcProvAUTh
		addlw	0x01				;Offset de NANO 26 Authorization
		movwf	EEADR2
		call	b1_Rd_Memory
		movwf	BUFFER+0
		xcall	Rd_Memory_Next
		movwf	BUFFER+1
		;movlw	0x02
		;xcall	LoadBuffer
		return

;****************************************************************************
; Calcula el offset en la eeprom externa del authorization del proveedor especificado en IC_P1
; Devuelve en EEADRH2:EEADR2
CalcProvAUTh
		movlw	HIGH(ProvAUTh-BASE_DATOS)
		movwf	EEADRH2
		movfw	IC_P1
		andlw	0x0F
		movwf	DUMMY1
		incf	DUMMY1,F
		movlw	LOW(ProvAUTh)
		goto	CalcProvAUTh_1
CalcProvAUTh_loop
		addlw	ProvAUThlen
		btfsc	STATUS,C
			incf    EEADRH2,f
CalcProvAUTh_1
		decfsz	DUMMY1,f
		goto	CalcProvAUTh_loop
		return

;**************************************************************************************************
;* SEARCH NANO                                                                                    *
;**************************************************************************************************
SearchNano
		clrf    FSR2			;Init FSR2
SearchNanoNext          
		movwf   DUMMY1
SearchNano_loop             
		movf    FSR2,W
		subwf   IC_LEN,W
		btfsc   STATUS,Z
		retlw   0x01
		call   	b1_Restore
		movwf   DUMMY2
		xorwf   DUMMY1,W
		btfsc   STATUS,Z
			retlw   0x00            ;Se ha encontrado el nano
		swapf   DUMMY2,W
		andlw   0x0F
		call	NanoLength
SearchNano_next
		addwf   FSR2,F
		goto    SearchNano_loop

;*******************
; Check Key Routine
;*******************
Chk_Key
		rrf	IC_P2,w      ;devuelve incorrecto para keys 4-b
		xorwf	IC_P2,w
		andlw	0x04
		btfss	STATUS,Z
		retlw	0x02

		movlw	SK
		movwf	FSR
		movlw	0x08
		movwf	DUMMY1
Chk_Key_loop
		movf	INDF,w
		btfss	STATUS,Z
		retlw	0x00
		incf	FSR,f
		decfsz	DUMMY1,f
		goto	Chk_Key_loop
		retlw	0x02

;***********************
; Check Provider Routine
;***********************
Chk_Provider
		movlw	HIGH	(I16_ANS-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW	(I16_ANS-BASE_DATOS)+2
		btfss	IC_P1,3
			addlw	0x01
		call	b1_Rd_Memory
		movwf	TEMP+0
		movf	IC_P1,w
		andlw	0x07
		movwf	COUNTER
		incf	COUNTER,f
Chk_Provider_loop
		rrf	TEMP+0,f
		decfsz	COUNTER,f
		goto 	Chk_Provider_loop
		return

;-----------------------------------------------------------------
;This routine calculate NANOBitmap for STATUS BYTE 97xx
CalcNANOBitmap
		movfw	NANOCNT

		xorlw	(0x01)
		btfsc	STATUS,Z
			bsf	NANOBitmap,0
		xorlw	(0x02 ^ 0x01)
		btfsc	STATUS,Z
			bsf	NANOBitmap,1
		xorlw	(0x03 ^ 0x02)
		btfsc	STATUS,Z
			bsf	NANOBitmap,2
		xorlw	(0x04 ^ 0x03)
		btfsc	STATUS,Z
			bsf	NANOBitmap,3
		xorlw	(0x05 ^ 0x04)
		btfsc	STATUS,Z
			bsf	NANOBitmap,4
		xorlw	(0x06 ^ 0x05)
		btfsc	STATUS,Z
			bsf	NANOBitmap,5
		xorlw	(0x07 ^ 0x06)
		btfsc	STATUS,Z
			bsf	NANOBitmap,6
		xorlw	(0x08 ^ 0x07)
		btfsc	STATUS,Z
			bsf	NANOBitmap,7

		bcf	EcmEMM_CONTROL,5		;Deshabilita bit 5 (UPDATE Done)
		bsf	EcmEMM_CONTROL,7		;Habilita bit 7
		return

;**************************************************************************************************
;* Envio del Status Word                                                                          *
;**************************************************************************************************
TX90xx
		movwf	DUMMY4
		movlw	0x90
		call	b1_Send
		movfw	DUMMY4
		btfss	STATUS,Z
		bsf	CONTROL2,1
		goto	SendMain
TX6700					;Incorrect length
		movlw	0x67
		goto	Txxx00BADINS
TX6D00					;Instruction not supported/valid or Instruction protected
		movlw	0x6D
Txxx00BADINS	bsf	CONTROL2,1
		goto	TXxx00
TX9002					;Wrong or missing signature
		movlw	0x02
		goto	TX90xx

PROV_ERROR	xcall	Send_FF
TX9004					;Provider not supported
		movlw	0x04
		goto	TX90xx
TX9005					;Only allowed for SECA
		movlw	0x05
		goto	TX90xx
TX9007					;Not allowed - provider blocked ( NANO 01/02 Auth )
		movlw	0x07
		goto	TX90xx
TX9008					;Nano 0x01 not allowed4
		movlw	0x08
		goto	TX90xx
TX9009					;PPUA not in F0-bitmap
		movlw	0x09
		goto	TX90xx
TX9010					;Wrong PIN
		movlw	0x10
		goto	TX90xx
TX9011					;Testbit not set, Instruction not supported
		movlw	0x11
		goto	TX90xx
TX9013					;MK needed
		movlw	0x13
		goto	TX90xx

PREVINS_ERROR	bsf	LEDS,1
		xcall	Send_FF
TX9014					;Prev. ins error
		movlw	0x14
		goto	TX90xx
TX9015					;Nano not allowed for or Unsupported input value
		movlw	0x15
		goto	TX90xx
TX9019					;PPUA changed
		movlw	0x19
		goto	TX90xx
TX901D					;Primary Key not found
		movlw	0x1D
		goto	TX90xx
TX901F					;Secondary Key not found
		movlw	0x1F
		goto	TX90xx
TX9021					;Key is not 0F - Rejected
		movlw	0x21
		goto	TX90xx
TX9301					;Card has expired
		movlw	0x93
		call	b1_Send            	
		movlw	0x01
		goto	SendMain
TX9302					;No decoding
		movlw	0x93
		call	b1_Send            	
		movlw	0x02
		goto	SendMain
TX9304					;Parental guidance to low
		movlw	0x93
		call	b1_Send            	
		movlw	0x04
		goto	SendMain

P2_ERROR	xcall	Send_FF
TX9402					;Wrong P2 value
		movlw	0x94
		call	b1_Send            	
		movlw	0x02
		goto	SendMain
TX96XX					;XX nanos processed fine, no nano 0xD1 found or All nanos were processed fine
		movlw	0x96
		call	b1_Send
		movfw	NANOCNT
		goto	SendMain
TX97xx					;Updating the EEPROM was not necessary for some nanos - bitmap xx
		movlw	0x97
		call	b1_Send
		movfw	NANOBitmap
		goto	SendMain
TX9801
		movlw	0x98
		call	b1_Send
		movlw	0x01
		goto	SendMain

;****************************************************************************************
; Stubs para las rutinas generales en el banco de memoria 0 y otras rutinas en el banco 1 
;****************************************************************************************
		errorlevel -306
b1_Send
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Send
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_ChkSend
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	ChkSend
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Receive
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Receive
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Rd_eeprom
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Rd_eeprom
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Wr_eeprom
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Wr_eeprom
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Store
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Store
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Restore
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Restore
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Wr_Memory
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Wr_Memory
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Rd_Memory
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Rd_Memory
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_Send_FF
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	Send_FF
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
b1_FLASH_send
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	FLASH_send
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return

b1_LoadBuffer
		bcf	PCLATH,3		; Swap to program Block 0 (0x0000-0x07FF)
		call	LoadBuffer
		bsf	PCLATH,3		; Swap to program Block 1 (0x0800-0x0FFF)
		return
		
		errorlevel +306

;------------------------------------------------------------------------------------------------------------
I0A_ANS		DW		0x61,0x19,0xAD,0xCA,0x15,0x2F,0x10,0x03
CHECK_EEPROM	DW		0x00,0x00
CRC_ROM		DW		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
			DW		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
S.O.ROM		DW		0x28,0x43,0x29,0x43,0x41,0x4E,0x41,0x4C,0x2B,0x31,0x39,0x39,0x34,0x2F,0x39,0x35
			DW		0x2F,0x39,0x36,0x20,0x4E,0x75,0x6D,0x34,0x31,0x00
I0ALen		EQU	$-I0A_ANS

I1A_ANS		DW	0xFF,0xFF,0x0C,0x84
I1ALen		EQU	$-I1A_ANS

;Startup Record total
;Valid for any provider
I32_STARTUP		DW	0xB2,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x89,0x9b
I32_STARTUPLen	EQU	$-I32_STARTUP

I32_ACTIVATION	DW	0xB2,0x02,0x12,0x04,0x20,0x01,0x00,0x00,0x00,0x00,0x00,0x00
I32_ACTIVATIONLen	EQU	$-I32_ACTIVATION

I32_PPV		DW	0xB1,0x01,0x00,0x00,0x0F,0x04,0x01,0x00,0x16,0x8c,0x00,0x00

I32_PROPPV		DW	0xD1,0x00,0x04,0x00,0x00,0x00,0x17,0x7e,0x00,0x04,0xff,0xff
I32_PROPPVLen	EQU	$-I32_PROPPV


		include "eeprom.inc"

;******************************************************************************************************
;* Valores en la EEPROM INTERNA del 16F876
;******************************************************************************************************
			ORG	0x2100
; Configuracin
#ifndef COMPILE_873_VERSION
CONFIGBYTE	DATA    0x04
#else
CONFIGBYTE	DATA    0x04
#endif

; Dedicados a identificar la version ( 14 byte free )
PIC2RD_INFO	DE		VersionPIC2RD
		DE		VER_MAJOR
		DE		VER_MINOR
		DE		VersionRev
		DE		HIGH	(DATE)
		DE		LOW	(DATE)

; Lista de comandos implementados
CmdList	DATA	0x0A,0x0E,0x7C,0x16,0x12,0x34,0x32,0x30,0x3A,0x3C,0x40,0x1A,0x5A
	DATA	0x02,0x04,0x36,0x38,0x42,0x48,0x4A,0x4C,0x50,0x54,0x56,0x5C,0x8A
LOG_FILTER
			ORG	0x212E
LOG_FILTER_END
; Pin
PIN		DATA    0,0
CONFIGEX	DATA	0x00,0x00,0x00,0x00	   ;CONTROLA, CONTROLB, CONTROLC, CONTROLD

#ifdef COMPILE_873_VERSION
			ORG	0x2136	; Tabla en memoria para guardar los eventos PPV
PPVTBL		RES	PPVMAXBYTES	; Reservamos una tabla con los eventos
#endif

			ORG	0x2168
BAUDRATE	DATA	0x05			;9322 bps @ 3.579545 MHz

			ORG	0x2170
MAXLOG		DATA    0x04,0x00
CONFIGLOG	DATA    0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
LOGCOUNTER	DATA    0x00,0x00
POSLOG		DATA    0x0C,0x00

;******************************************************************************************************
		END
